// Sample_MFCView.h : CSample_MFCView Interface of class
//


#pragma once

#include "CArtCamSdk.hpp"

const TCHAR DLLNAMELIST[][32] = {
	"ArtCamSdk.dll",
	"",
	"ArtCamSdk_USTC.dll",
	"ArtCnvSdk.dll",
	"",
	"ArtCamSdk_130MI.dll",
	"ArtCamSdk_200MI.dll",
	"ArtCamSdk_300MI.dll",
	"ArtCamSdk_150P.dll",
	"ArtCamSdk_320P.dll",
	"ArtCamSdk_200SH.dll",
	"ArtCamSdk_098.dll",
	"ArtCamSdk_036MI.dll",
	"ArtCamSdk_500P.dll",
	"ArtCamSdk_150P2.dll"
};

const TCHAR ERRORLIST[][128] = {
	"",
	"Not initialized",
	"Access to unavailable device was attempted",
	"Failure of thread creation for capturing",
	"Window creation failed",
	"Not enough memory for image transfer/Failure for securing memory",
	"Error for camera (device) settings",
	"Error for camera (device) size settings",
	"Capturing failed",
	"Wrong argument",
	"Directshow initialization error",
	"Not supported",
	"Unknow error",
	"Device lost",
};

const int DLLCOUNT = sizeof(DLLNAMELIST)/32;
const int ERRORCOUNT = sizeof(ERRORLIST)/128;





class CSample_MFCView : public CView
{
	CArtCamSdk	m_CArtCamSdk;
	LPBYTE		m_pImage;			// Space for image data
	BOOL		m_PreviewMode;		// Preview display/Callback display
	LONG		m_DllType;			// DLL to be connected
	LONG		m_DeviceCount;		// Number of detected device
	LONG		m_SelectDevice;		// Number of chosen device

	BOOL		m_SaveFlg;			// Deicide if save is available
	BOOL		m_StopFlg;			// Determination of stoppage
	CString		m_RecName;			// Name of recorded file

	BOOL		m_MenuEnable[DLLCOUNT];


	LRESULT	DrawImage		(HDC hDC);
	BOOL	OnDllChange		(LONG DllType);
	BOOL	OnDeviceChange	(LONG Number);
	void	ChangeScrollbar	(void);

public:
	void InitMenuPopup(CMenu* pPopupMenu);



protected: // Only created from serialization
	CSample_MFCView();
	DECLARE_DYNCREATE(CSample_MFCView)

// Attribute
public:
	CSample_MFCDoc* GetDocument() const;

// Operation
public:

// Override
	public:
	virtual void OnDraw(CDC* pDC);  // Override to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// Mounting
public:
	virtual ~CSample_MFCView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Function for allocating message generated
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg LRESULT OnGraphPaint(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnError(WPARAM wParam, LPARAM lParam);
	afx_msg void OnFileSaveimage();
	afx_msg void OnFileRec();
	afx_msg void OnExit();
	afx_msg void OnShowPreview();
	afx_msg void OnShowCallback();
	afx_msg void OnShowSnapshot();
	afx_msg void OnShowCapture();
	afx_msg void OnShowTrigger();
	afx_msg void OnShowStop();
	afx_msg void OnSetFormat();
	afx_msg void OnSetFilter();
	afx_msg void OnSetAnalog();
	afx_msg void OnSetFilterApp();
	afx_msg void OnDllCam();
	afx_msg void OnDllUstc();
	afx_msg void OnDllCnv();
	afx_msg void OnDll130mi();
	afx_msg void OnDll200mi();
	afx_msg void OnDll300mi();
	afx_msg void OnDll150p();
	afx_msg void OnDll320p();
	afx_msg void OnDllMv03();
	afx_msg void OnDll200sh();
	afx_msg void OnDll098();
	afx_msg void OnDll036mi();
	afx_msg void OnDll500p();
	afx_msg void OnDll150p2();
	afx_msg void OnDevice01();
	afx_msg void OnDevice02();
	afx_msg void OnDevice03();
	afx_msg void OnDevice04();
	afx_msg void OnDevice05();
	afx_msg void OnDevice06();
	afx_msg void OnDevice07();
	afx_msg void OnDevice08();
	afx_msg void OnSetSizeApp();
};

#ifndef _DEBUG  // Debugging version of Sample_MFCView.cpp
inline CSample_MFCDoc* CSample_MFCView::GetDocument() const
   { return reinterpret_cast<CSample_MFCDoc*>(m_pDocument); }
#endif

