// Sample_MFCView.h : CSample_MFCView Declare class and define interface
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SAMPLE_MFCVIEW_H__4D1F186C_F1CF_426F_BC06_92DD0D26DEFC__INCLUDED_)
#define AFX_SAMPLE_MFCVIEW_H__4D1F186C_F1CF_426F_BC06_92DD0D26DEFC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "CArtCamSdk.hpp"

const TCHAR DLLNAMELIST[][32] = {
	"ArtCamSdk.dll",
	"",
	"ArtCamSdk_USTC.dll",
	"ArtCnvSdk.dll",
	"",
	"ArtCamSdk_130MI.dll",
	"ArtCamSdk_200MI.dll",
	"ArtCamSdk_300MI.dll",
	"ArtCamSdk_150P.dll",
	"ArtCamSdk_320P.dll",
	"ArtCamSdk_200SH.dll",
	"ArtCamSdk_098.dll",
	"ArtCamSdk_036MI.dll",
	"ArtCamSdk_500P.dll",
	"ArtCamSdk_150P2.dll"
};

const TCHAR ERRORLIST[][128] = {
	"",
	"Not initialized",
	"Access to unavailable device was attempted",
	"Failure of thread creation for capturing",
	"Window creation failed",
	"Not enough memory for image transfer/Failure for securing memory",
	"Error for camera (device) settings",
	"Error for camera (device) size settings",
	"Capturing failed",
	"Wrong argument",
	"Directshow initialization error",
	"Not supported",
	"Unknow error",
	"Device lost",
};

const int DLLCOUNT = sizeof(DLLNAMELIST)/32;
const int ERRORCOUNT = sizeof(ERRORLIST)/128;







class CSample_MFCView : public CView
{
	CArtCamSdk	m_CArtCamSdk;
	LPBYTE		m_pImage;			// Space for image data
	BOOL		m_PreviewMode;		// Preview display/Callback display
	LONG		m_DllType;			// DLL to be connected
	LONG		m_DeviceCount;		// Number of detected device
	LONG		m_SelectDevice;		// Number of chosen device

	BOOL		m_SaveFlg;			// Deicide if save is available
	BOOL		m_StopFlg;			// Determination of stoppage
	CString		m_RecName;			// Name of recorded file

	BOOL		m_MenuEnable[DLLCOUNT];


	LRESULT	DrawImage		(HDC hDC);
	BOOL	OnDllChange		(LONG DllType);
	BOOL	OnDeviceChange	(LONG Number);
	void	ChangeScrollbar	(void);

public:
	void InitMenuPopup(CMenu* pPopupMenu);



protected: // Create only from serialization function
	CSample_MFCView();
	DECLARE_DYNCREATE(CSample_MFCView)

// Attribute
public:
	CSample_MFCDoc* GetDocument();

// Operation
public:

// Override
	// ClassWizard creates override of hypothetical function
	//{{AFX_VIRTUAL(CSample_MFCView)
	public:
	virtual void OnDraw(CDC* pDC);  // Override to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSample_MFCView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Created message map function
protected:
	//{{AFX_MSG(CSample_MFCView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnGraphPaint(WPARAM wParam, LPARAM lParam);
	afx_msg void OnError(WPARAM wParam, LPARAM lParam);
	afx_msg void OnFileSaveimage();
	afx_msg void OnFileRec();
	afx_msg void OnExit();
	afx_msg void OnShowPreview();
	afx_msg void OnShowCallback();
	afx_msg void OnShowSnapshot();
	afx_msg void OnShowCapture();
	afx_msg void OnShowTrigger();
	afx_msg void OnShowStop();
	afx_msg void OnSetFormat();
	afx_msg void OnSetFilter();
	afx_msg void OnSetAnalog();
	afx_msg void OnSetFilterApp();
	afx_msg void OnDllCam();
	afx_msg void OnDllUstc();
	afx_msg void OnDllCnv();
	afx_msg void OnDll130mi();
	afx_msg void OnDll200mi();
	afx_msg void OnDll300mi();
	afx_msg void OnDll150p();
	afx_msg void OnDll320p();
	afx_msg void OnDllMv03();
	afx_msg void OnDll200sh();
	afx_msg void OnDll098();
	afx_msg void OnDll036mi();
	afx_msg void OnDll500p();
	afx_msg void OnDll150p2();
	afx_msg void OnDevice01();
	afx_msg void OnDevice02();
	afx_msg void OnDevice03();
	afx_msg void OnDevice04();
	afx_msg void OnDevice05();
	afx_msg void OnDevice06();
	afx_msg void OnDevice07();
	afx_msg void OnDevice08();
	afx_msg void OnSetSizeApp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Sample_MFCView.cpp File is used under condition of debugging
inline CSample_MFCDoc* CSample_MFCView::GetDocument()
   { return (CSample_MFCDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ inserts additional declaration before the front line.

#endif // !defined(AFX_SAMPLE_MFCVIEW_H__4D1F186C_F1CF_426F_BC06_92DD0D26DEFC__INCLUDED_)
