// SetFilterDlg.cpp : Implementation File
//

#include "stdafx.h"
#include "Sample_MFC.h"
#include "SetFilterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetFilterDlg Dialog


CSetFilterDlg::CSetFilterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetFilterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetFilterDlg)
		// Memo: ClassWizard add/delete macro for mapping at this position.
	//}}AFX_DATA_INIT

	m_Init = FALSE;
	m_DllType = -1;
	m_pCArtCamSdk = NULL;
	m_Preview = -1;
}


void CSetFilterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetFilterDlg)
		// Memo: ClassWizard add/delete macro for mapping at this position.
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetFilterDlg, CDialog)
	//{{AFX_MSG_MAP(CSetFilterDlg)
	ON_BN_CLICKED(IDC_MIRROR_V, OnMirrorV)
	ON_BN_CLICKED(IDC_MIRROR_H, OnMirrorH)
	ON_BN_CLICKED(IDC_AWB, OnAwb)
	ON_BN_CLICKED(IDR_BAYER1, OnBayer1)
	ON_BN_CLICKED(IDR_BAYER2, OnBayer2)
	ON_BN_CLICKED(IDR_BAYER3, OnBayer3)
	ON_BN_CLICKED(IDR_BAYER4, OnBayer4)
	ON_BN_CLICKED(IDR_AI1, OnAi1)
	ON_BN_CLICKED(IDR_AI2, OnAi2)
	ON_BN_CLICKED(IDR_AI3, OnAi3)
	ON_BN_CLICKED(IDC_HALFCLOCK, OnHalfclock)
	ON_BN_CLICKED(IDR_CHANNEL1, OnChannel1)
	ON_BN_CLICKED(IDR_CHANNEL2, OnChannel2)
	ON_BN_CLICKED(IDR_CHANNEL3, OnChannel3)
	ON_BN_CLICKED(IDR_CHANNEL4, OnChannel4)
	ON_BN_CLICKED(IDR_CHANNEL5, OnChannel5)
	ON_BN_CLICKED(IDR_CHANNEL6, OnChannel6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetFilterDlg Message handler

BOOL CSetFilterDlg::OnInitDialog() 
{
	m_Init = FALSE;

	CDialog::OnInitDialog();


	// Change operation for each DLL
	// For each DLL function, please refer to manual.
	m_DllType = HIWORD(m_pCArtCamSdk->GetDllVersion());

	// Preset value of each camera
	// Refer to "Preset value of image filter".
	short CameraData[18][2][3] = {
		{	{ 0, 0, 0 },	{    0,  0,     0 },	},		// 
		{	{ 0, 0, 0 },	{    0,  0,     0 },	},		// DirectShow
		{	{ 0, 0, 0 },	{    0,  0,     0 },	},		// 
		{	{ 0, 0, 0 },	{    0,  0,     0 },	},		// ARTUST
		{	{ 0, 0, 0 },	{    0,  0,     0 },	},		// ARTCNV
		{	{ 0, 0, 0 },	{    0,  0,     0 },	},		// 
		{	{ 0, 0, 1 },	{   63, 63, 16383 },	},		// ARTCAM-130MI
		{	{ 0, 0, 0 },	{    0,  0,     0 },	},		// 
		{	{ 0, 0, 1 },	{   63, 63, 16383 },	},		// ARTCAM-200MI
		{	{ 0, 0, 1 },	{   63, 63, 16383 },	},		// ARTCAM-300MI
		{	{ 0, 0, 0 },	{  231,  0,     7 },	},		// ARTCAM-150P
		{	{ 0, 0, 0 },	{  231,  0,     7 },	},		// ARTCAM-320P
		{	{ 0, 0, 0 },	{    0,  0,     0 },	},		// 
		{	{ 0, 0, 0 },	{  511,  0,  1023 },	},		// ARTCAM-200SH
		{	{ 0, 0, 0 },	{  511,  0,     8 },	},		// ARTCAM-098
		{	{ 0, 0, 1 },	{  127,  0,   480 },	},		// ARTCAM-036MI
		{	{ 0, 0, 0 },	{ 1023,  0,  2047 },	},		// ARTCAM-500P
		{	{ 0, 0, 0 },	{  255,  0,  1023 },	},		// ARTCAM-150PII
	};


	// Range for value is set while determination of availability is done. 
	if(ARTCAM_CAMERATYPE_CNV == m_DllType){
		InitControl(ARTCAM_FILTERTYPE_BRIGHTNESS,		IDE_BRIGHTNESS,		IDS_BRIGHTNESS,		0,	255);
		InitControl(ARTCAM_FILTERTYPE_CONTRAST,			IDE_CONTRAST,		IDS_CONTRAST,		0,	255);
		InitControl(ARTCAM_FILTERTYPE_HUE,				IDE_HUE,			IDS_HUE,			0,	255);
		InitControl(ARTCAM_FILTERTYPE_SATURATION,		IDE_SATURATION,		IDS_SATURATION,		0,	255);
		InitControl(ARTCAM_FILTERTYPE_SHARPNESS,		IDE_SHARPNESS,		IDS_SHARPNESS,		0,	  0);
		InitControl(ARTCAM_FILTERTYPE_BAYER_GAIN_R,		IDE_BAYER_GAIN_R,	IDS_BAYER_GAIN_R,	0,	  0);
		InitControl(ARTCAM_FILTERTYPE_BAYER_GAIN_G,		IDE_BAYER_GAIN_G,	IDS_BAYER_GAIN_G,	0,	  0);
		InitControl(ARTCAM_FILTERTYPE_BAYER_GAIN_B,		IDE_BAYER_GAIN_B,	IDS_BAYER_GAIN_B,	0,	  0);
		InitControl(ARTCAM_FILTERTYPE_GAMMA,			IDE_GAMMA,			IDS_GAMMA,			0,	  0);
	} else {
		InitControl(ARTCAM_FILTERTYPE_BRIGHTNESS,		IDE_BRIGHTNESS,		IDS_BRIGHTNESS,		-255,	255);
		InitControl(ARTCAM_FILTERTYPE_CONTRAST,			IDE_CONTRAST,		IDS_CONTRAST,		-127,	127);
		InitControl(ARTCAM_FILTERTYPE_HUE,				IDE_HUE,			IDS_HUE,			-360,	360);
		InitControl(ARTCAM_FILTERTYPE_SATURATION,		IDE_SATURATION,		IDS_SATURATION,		-255,	255);
		InitControl(ARTCAM_FILTERTYPE_SHARPNESS,		IDE_SHARPNESS,		IDS_SHARPNESS,		   0,	 30);
		InitControl(ARTCAM_FILTERTYPE_BAYER_GAIN_R,		IDE_BAYER_GAIN_R,	IDS_BAYER_GAIN_R,	   0,	200);
		InitControl(ARTCAM_FILTERTYPE_BAYER_GAIN_G,		IDE_BAYER_GAIN_G,	IDS_BAYER_GAIN_G,	   0,	200);
		InitControl(ARTCAM_FILTERTYPE_BAYER_GAIN_B,		IDE_BAYER_GAIN_B,	IDS_BAYER_GAIN_B,	   0,	200);
		InitControl(ARTCAM_FILTERTYPE_GAMMA,			IDE_GAMMA,			IDS_GAMMA,			   0,	200);
	}


	InitControl(ARTCAM_FILTERTYPE_GLOBAL_GAIN,		IDE_GLOBAL_GAIN,	IDS_GLOBAL_GAIN,	CameraData[m_DllType][0][0], CameraData[m_DllType][1][0]);
	InitControl(ARTCAM_FILTERTYPE_COLOR_GAIN_R,		IDE_COLOR_GAIN_R,	IDS_COLOR_GAIN_R,	CameraData[m_DllType][0][1], CameraData[m_DllType][1][1]);
	InitControl(ARTCAM_FILTERTYPE_COLOR_GAIN_G1,	IDE_COLOR_GAIN_G1,	IDS_COLOR_GAIN_G1,	CameraData[m_DllType][0][1], CameraData[m_DllType][1][1]);
	InitControl(ARTCAM_FILTERTYPE_COLOR_GAIN_G2,	IDE_COLOR_GAIN_G2,	IDS_COLOR_GAIN_G2,	CameraData[m_DllType][0][1], CameraData[m_DllType][1][1]);
	InitControl(ARTCAM_FILTERTYPE_COLOR_GAIN_B,		IDE_COLOR_GAIN_B,	IDS_COLOR_GAIN_B,	CameraData[m_DllType][0][1], CameraData[m_DllType][1][1]);
	InitControl(ARTCAM_FILTERTYPE_EXPOSURETIME,		IDE_EXPOSURETIME,	IDS_EXPOSURETIME,	CameraData[m_DllType][0][2], CameraData[m_DllType][1][2]);


	// Auto white balance
	BOOL Error = FALSE;
	LONG Data = m_pCArtCamSdk->GetFilterValue(ARTCAM_FILTERTYPE_BAYER_GAIN_AUTO, &Error);
	if(!Error){
		GetDlgItem(IDC_AWB)->EnableWindow(FALSE);
	}
	if(Data){
		CheckDlgButton(IDC_AWB, BST_CHECKED);
	}


	// Bayer conversion mode
	Error = FALSE;
	Data = m_pCArtCamSdk->GetFilterValue(ARTCAM_FILTERTYPE_BAYERMODE, &Error);
	if(!Error){
		GetDlgItem(IDR_BAYER1)->EnableWindow(FALSE);
		GetDlgItem(IDR_BAYER2)->EnableWindow(FALSE);
		GetDlgItem(IDR_BAYER3)->EnableWindow(FALSE);
		GetDlgItem(IDR_BAYER4)->EnableWindow(FALSE);
	}

	switch(Data){
	case 0:	CheckDlgButton(IDR_BAYER1, BST_CHECKED); break;
	case 1:	CheckDlgButton(IDR_BAYER2, BST_CHECKED); break; 
	case 2:	CheckDlgButton(IDR_BAYER3, BST_CHECKED); break;
	case 3:	CheckDlgButton(IDR_BAYER4, BST_CHECKED); break;
	}


	// Mirror reversal
	if(m_pCArtCamSdk->GetMirrorV())	CheckDlgButton(IDC_MIRROR_V, BST_CHECKED);
	if(m_pCArtCamSdk->GetMirrorH())	CheckDlgButton(IDC_MIRROR_H, BST_CHECKED);

	// Horizotal reversal is only available in 036MI.
	if(ARTCAM_CAMERATYPE_036MI != m_DllType){
		GetDlgItem(IDC_MIRROR_H)->EnableWindow(FALSE);
	}

	// Vertical reversal is not available in following models.
	switch(m_DllType){
	case ARTCAM_CAMERATYPE_DS:
	case ARTCAM_CAMERATYPE_USTC:
	case ARTCAM_CAMERATYPE_CNV:
	case ARTCAM_CAMERATYPE_150P:
	case ARTCAM_CAMERATYPE_150P2:
	case ARTCAM_CAMERATYPE_098:
		GetDlgItem(IDC_MIRROR_V)->EnableWindow(FALSE);
	break;
	}


	// Auto iris
	Error = FALSE;
	Data = m_pCArtCamSdk->GetAutoIris(&Error);
	switch(Data){
	case AI_NONE:		CheckDlgButton(IDR_AI1, BST_CHECKED);	break;
	case AI_EXPOSURE:	CheckDlgButton(IDR_AI2, BST_CHECKED);	break;
	case AI_GAIN:		CheckDlgButton(IDR_AI3, BST_CHECKED);	break;
	}

	if(!Error){
		GetDlgItem(IDR_AI1)->EnableWindow(FALSE);
		GetDlgItem(IDR_AI2)->EnableWindow(FALSE);
		GetDlgItem(IDR_AI3)->EnableWindow(FALSE);
	}

	// Camera without shutter function
	switch(m_DllType){
	case ARTCAM_CAMERATYPE_150P:
	case ARTCAM_CAMERATYPE_320P:
	case ARTCAM_CAMERATYPE_098:
		GetDlgItem(IDR_AI2)->EnableWindow(FALSE);
	break;
	}


	// Half clock
	Error = FALSE;
	if(m_pCArtCamSdk->GetHalfClock(&Error))	CheckDlgButton(IDC_HALFCLOCK, BST_CHECKED);
	if(!Error){
		GetDlgItem(IDC_HALFCLOCK)->EnableWindow(FALSE);
	}


	// Channel
	if(ARTCAM_CAMERATYPE_CNV != m_DllType){
		GetDlgItem(IDR_CHANNEL1)->EnableWindow(FALSE);
		GetDlgItem(IDR_CHANNEL2)->EnableWindow(FALSE);
		GetDlgItem(IDR_CHANNEL3)->EnableWindow(FALSE);
		GetDlgItem(IDR_CHANNEL4)->EnableWindow(FALSE);
		GetDlgItem(IDR_CHANNEL5)->EnableWindow(FALSE);
		GetDlgItem(IDR_CHANNEL6)->EnableWindow(FALSE);
	}



	m_Init = TRUE;

	return TRUE;
}


BOOL CSetFilterDlg::InitControl(LONG FilterType, UINT EditID, UINT SpinID, short Min, short Max)
{
	BOOL Error = 0;
	LONG Data = m_pCArtCamSdk->GetFilterValue(FilterType, &Error);


	CSpinButtonCtrl* Spin = (CSpinButtonCtrl*)GetDlgItem(SpinID);
	if(Spin){
		Spin->SetRange(Min, Max);
		Spin->SetPos(Data);
		Spin->SetBuddy(GetDlgItem(EditID));
	}

	// Error occurrence(no response)
	if(!Error){
		GetDlgItem(EditID)->EnableWindow(FALSE);
		return FALSE;
	}

	SetDlgItemInt(EditID, Data);

	return TRUE;
}


void CSetFilterDlg::OnOK() 
{

	CDialog::OnOK();
}

void CSetFilterDlg::OnCancel() 
{

	CDialog::OnCancel();
}


BOOL CSetFilterDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if(EN_CHANGE == HIWORD(wParam)){
		switch(LOWORD(wParam)){
		case IDE_BRIGHTNESS:	SetControl(ARTCAM_FILTERTYPE_BRIGHTNESS,	IDE_BRIGHTNESS,		IDS_BRIGHTNESS);	break;
		case IDE_CONTRAST:		SetControl(ARTCAM_FILTERTYPE_CONTRAST,		IDE_CONTRAST,		IDS_CONTRAST);		break;
		case IDE_HUE:			SetControl(ARTCAM_FILTERTYPE_HUE,			IDE_HUE,			IDS_HUE);			break;
		case IDE_SATURATION:	SetControl(ARTCAM_FILTERTYPE_SATURATION,	IDE_SATURATION,		IDS_SATURATION);	break;
		case IDE_SHARPNESS:		SetControl(ARTCAM_FILTERTYPE_SHARPNESS,		IDE_SHARPNESS,		IDS_SHARPNESS);		break;
		case IDE_BAYER_GAIN_R:	SetControl(ARTCAM_FILTERTYPE_BAYER_GAIN_R,	IDE_BAYER_GAIN_R,	IDS_BAYER_GAIN_R);	break;
		case IDE_BAYER_GAIN_G:	SetControl(ARTCAM_FILTERTYPE_BAYER_GAIN_G,	IDE_BAYER_GAIN_G,	IDS_BAYER_GAIN_G);	break;
		case IDE_BAYER_GAIN_B:	SetControl(ARTCAM_FILTERTYPE_BAYER_GAIN_B,	IDE_BAYER_GAIN_B,	IDS_BAYER_GAIN_B);	break;
		case IDE_GAMMA:			SetControl(ARTCAM_FILTERTYPE_GAMMA,			IDE_GAMMA,			IDS_GAMMA);			break;
		case IDE_GLOBAL_GAIN:	SetControl(ARTCAM_FILTERTYPE_GLOBAL_GAIN,	IDE_GLOBAL_GAIN,	IDS_GLOBAL_GAIN);	break;
		case IDE_COLOR_GAIN_R:	SetControl(ARTCAM_FILTERTYPE_COLOR_GAIN_R,	IDE_COLOR_GAIN_R,	IDS_COLOR_GAIN_R);	break;
		case IDE_COLOR_GAIN_G1:	SetControl(ARTCAM_FILTERTYPE_COLOR_GAIN_G1,	IDE_COLOR_GAIN_G1,	IDS_COLOR_GAIN_G1);	break;
		case IDE_COLOR_GAIN_G2:	SetControl(ARTCAM_FILTERTYPE_COLOR_GAIN_G2,	IDE_COLOR_GAIN_G2,	IDS_COLOR_GAIN_G2);	break;
		case IDE_COLOR_GAIN_B:	SetControl(ARTCAM_FILTERTYPE_COLOR_GAIN_B,	IDE_COLOR_GAIN_B,	IDS_COLOR_GAIN_B);	break;
		case IDE_EXPOSURETIME:	SetControl(ARTCAM_FILTERTYPE_EXPOSURETIME,	IDE_EXPOSURETIME,	IDS_EXPOSURETIME);	break;
		}
	}

	return CDialog::OnCommand(wParam, lParam);
}



BOOL CSetFilterDlg::SetControl(LONG FilterType, UINT EditID, UINT SpinID)
{
	if(m_Init){
		LONG Data = GetDlgItemInt(EditID);

		// Set the value to spin (rounds automatically by determining whether it is moving range or not).
		CSpinButtonCtrl* Spin = (CSpinButtonCtrl*)GetDlgItem(SpinID);
		if(Spin){
			Spin->SetPos(Data);

			// Re-acquisition
			Data = GetDlgItemInt(EditID);
		}

		m_pCArtCamSdk->SetFilterValue(FilterType, Data);
	}

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Mirror reversal
//

void CSetFilterDlg::OnMirrorV() 
{
	if(IsDlgButtonChecked(IDC_MIRROR_V)){
		m_pCArtCamSdk->SetMirrorV(TRUE);
	} else {
		m_pCArtCamSdk->SetMirrorV(FALSE);
	}
}

void CSetFilterDlg::OnMirrorH() 
{
	if(IsDlgButtonChecked(IDC_MIRROR_H)){
		m_pCArtCamSdk->SetMirrorH(TRUE);
	} else {
		m_pCArtCamSdk->SetMirrorH(FALSE);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Auto white balance
//

void CSetFilterDlg::OnAwb() 
{
	if(IsDlgButtonChecked(IDC_AWB)){
		m_pCArtCamSdk->SetFilterValue(ARTCAM_FILTERTYPE_BAYER_GAIN_AUTO, TRUE);
	} else {
		m_pCArtCamSdk->SetFilterValue(ARTCAM_FILTERTYPE_BAYER_GAIN_AUTO, FALSE);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Bayer conversion mode
//

void CSetFilterDlg::OnBayer1() 
{
	m_pCArtCamSdk->SetFilterValue(ARTCAM_FILTERTYPE_BAYERMODE, 0);
}

void CSetFilterDlg::OnBayer2() 
{
	m_pCArtCamSdk->SetFilterValue(ARTCAM_FILTERTYPE_BAYERMODE, 1);
}

void CSetFilterDlg::OnBayer3() 
{
	m_pCArtCamSdk->SetFilterValue(ARTCAM_FILTERTYPE_BAYERMODE, 2);
}

void CSetFilterDlg::OnBayer4() 
{
	m_pCArtCamSdk->SetFilterValue(ARTCAM_FILTERTYPE_BAYERMODE, 3);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Auto iris
//

void CSetFilterDlg::OnAi1() 
{
	m_pCArtCamSdk->SetAutoIris(AI_NONE);
}

void CSetFilterDlg::OnAi2() 
{
	m_pCArtCamSdk->SetAutoIris(AI_EXPOSURE);
}

void CSetFilterDlg::OnAi3() 
{
	m_pCArtCamSdk->SetAutoIris(AI_GAIN);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Half clock
//

void CSetFilterDlg::OnHalfclock() 
{
	LONG Flg = IsDlgButtonChecked(IDC_HALFCLOCK);
	if(-1 != m_Preview){
		// To switch clock, display needs to be stopped.
		SetCursor(::LoadCursor(NULL, IDC_WAIT));
		m_pCArtCamSdk->StopPreview();
	}
	m_pCArtCamSdk->SetHalfClock(Flg);

	if(-1 != m_Preview){
		// Resume display
		m_pCArtCamSdk->StartPreview();
		SetCursor(::LoadCursor(NULL, IDC_ARROW));
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Switch to channel
//

void CSetFilterDlg::OnChannel1(){	m_pCArtCamSdk->SetCrossbar(0, 0);	}
void CSetFilterDlg::OnChannel2(){	m_pCArtCamSdk->SetCrossbar(1, 0);	}
void CSetFilterDlg::OnChannel3(){	m_pCArtCamSdk->SetCrossbar(2, 0);	}
void CSetFilterDlg::OnChannel4(){	m_pCArtCamSdk->SetCrossbar(3, 0);	}
void CSetFilterDlg::OnChannel5(){	m_pCArtCamSdk->SetCrossbar(4, 0);	}
void CSetFilterDlg::OnChannel6(){	m_pCArtCamSdk->SetCrossbar(5, 0);	}

