//==========================================================
//	ARTRAY Camera / Capture Module Software Developer Kit
//						vr[^R[obN@\gpTv
//						VC++.NET Win32vWFNg
//
//									(C) 2002-2005 Artray
//==========================================================




//////////////////////////////////////////////////////////////////////////////////////////////
//
//	CN[ht@C
//

#include <windows.h>
#include <stdio.h>

// CuCN[h
#include "CArtCamSdk.hpp"



// e탁j[hc
enum {
	IDM_SAVE = WM_USER + 1,
	IDM_EXIT,

	IDM_PREVIEW,
	IDM_CALLBACK,
	IDM_SNAPSHOT,
	IDM_CAPTURE,
	IDM_TRIGGER,

	IDM_FORMAT1,
	IDM_FORMAT2,
	IDM_FILTER1,
	IDM_FILTER2,
	IDM_ANALOG1,
	IDM_ANALOG2,

	IDM_CAM,
	IDM_USTC,
	IDM_CNV,
	IDM_130MI,
	IDM_200MI,
	IDM_300MI,
	IDM_150P,
	IDM_320P,
	IDM_200SH,
	IDM_098,
	IDM_036MI,
	IDM_500P,
	IDM_150P2,
	IDM_500MI,
	IDM_T111,
	IDM_T112,
	IDM_150P3,
	IDM_130MIV,
	IDM_150P3V,
	IDM_267KY,
	IDM_274KY,
	IDM_625KY,
	IDM_V135MI,
	IDM_SATA,
	IDM_445KY,
	IDM_098II,
	IDM_MV413,
	IDM_OV210,
	IDM_850SH,
	IDM_1251SH,
        IDM_D131,
	IDM_900MI,
	IDM_1000MI,
	IDM_500P2,
	IDM_SATA_LVDS,
	IDM_SATA_300MI,
	IDM_SATA_500MI,
	IDM_SATA_MV413,
	IDM_SATA_800MI,
	IDM_SATA_036MI,
	IDM_SATA_150P3,
	IDM_SATA_267KY,
	IDM_SATA_274KY,
	IDM_SATA_625KY,
	IDM_SATA_130MI,
	IDM_SATA_200MI,
};



#define TIMER_ID	100
#define TIMER_TIME	50



CArtCamSdk	g_CArtCamSdk[2];
LPBYTE		g_pImage[2] = {NULL,NULL};		// 摜f[^i[̈

BOOL		g_Preview = -1;			// vr[\^R[obN\
LONG		g_DllType = -1;			// ڑDLL
LONG		g_CameraType = -1;		// ڑJ
LONG		g_DeviceCount = 0;		// oꂽfoCX̐


const int SUB_SAMPLE[] = { 1, 2, 4, 8 };
#define ArtCamGetWidth(n)	(g_CArtCamSdk[n].Width()  / SUB_SAMPLE[g_CArtCamSdk[n].GetSubSample()])
#define ArtCamGetHeight(n)	(g_CArtCamSdk[n].Height() / SUB_SAMPLE[g_CArtCamSdk[n].GetSubSample()])
#define ArtCamGetColor(n)	WORD(((g_CArtCamSdk[n].GetColorMode() + 7) / 8) * 8)
#define ArtCamGetBpp(n)		(((g_CArtCamSdk[n].GetColorMode() + 7) / 8))
#define ArtCamGetPitch(n)	((ArtCamGetWidth(n) * ArtCamGetBpp(n) + 3) & ~3)
#define ArtCamGetSize(n)	(ArtCamGetPitch(n) * ArtCamGetHeight(n))
#define SAFE_DELETE(x)  { if(x) delete[] x; x=NULL; }


struct MENU_LIST{
	HMENU	File;
	HMENU	Preview;
	HMENU	Set;
	HMENU	Dll;
};

MENU_LIST g_Menu;



const TCHAR DLLNAMELIST[][32] = {
	"ArtCamSdk.dll",
	"",
	"ArtCamSdk_USTC.dll",
	"ArtCnvSdk.dll",
	"",
	"ArtCamSdk_130MI.dll",
	"ArtCamSdk_200MI.dll",
	"ArtCamSdk_300MI.dll",
	"ArtCamSdk_150P.dll",
	"ArtCamSdk_320P.dll",
	"ArtCamSdk_200SH.dll",
	"ArtCamSdk_098.dll",
	"ArtCamSdk_036MI.dll",
	"ArtCamSdk_500P.dll",
	"ArtCamSdk_150P2.dll",
	"ArtCamSdk_500MI.dll",
	"ArtCamSdk_T111.dll",
	"ArtCamSdk_T112.dll",
	"ArtCamSdk_150P3.dll",
	"ArtCamSdk_130MIV.dll",
	"ArtCamSdk_150P3V.dll",
	"ArtCamSdk_267KY.dll",
	"ArtCamSdk_274KY.dll",
	"ArtCamSdk_625KY.dll",
	"ArtCamSdk_V135MI.dll",
	"",
	"ArtCamSdk_SATA.dll",
        "",
	"ArtCamSdk_445KY.dll",
	"ArtCamSdk_098II.dll",
	"ArtCamSdk_MV413.dll",
	"ArtCamSdk_OV210.dll",
	"ArtCamSdk_850SH.dll",
	"ArtCamSdk_1251SH.dll",
    "ArtCamSdl_D131.dll",
	"ArtCamSdk_900MI.dll",
	"ArtCamSdk_1000MI.dll",
	"ArtCamSdk_500P2.dll",
};

const TCHAR ERRORLIST[][128] = {
	"",
	"Ă܂",
	"ps\ȃfoCXɃANZX悤Ƃ܂",
	"摜荞ݗpXbh쐬Ɏs",
	"EBhE쐬Ɏs",
	"C[W]ɏ\ȃmۂĂȂ@́@̊mۂɎs",
	"JifoCXj̐ݒŃG[",
	"JifoCXj̃TCYݒŃG[",
	"f荞݂Ŏs",
	"ԈĂ܂",
	"DirectShow G[",
	"̋@\̓T|[gĂ܂",
	"s̃G[",
	"foCX܂",
	"wt@C܂",
	"FPGA̐ݒŃG[",
};

const int DLLCOUNT   = sizeof(DLLNAMELIST)/ ( 32 * sizeof(TCHAR));
const int ERRORCOUNT = sizeof(ERRORLIST)  / (128 * sizeof(TCHAR));

LONG DefProc = NULL;


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	摜`
//

struct BITMAPINFO2 {
	BITMAPINFOHEADER   bmiHeader;
	RGBQUAD            bmiColors[256];
};

LRESULT DrawImage(HWND hWnd, HDC hDC, LONG Number)
{
	LPBYTE pImage = g_pImage[Number];


	if(NULL == pImage){
		return 0;
	}

	BOOL Flg = FALSE;
	if(NULL == hDC){
		hDC = GetDC(hWnd);
		Flg = TRUE;
	}

	if(hDC){
		LONG Width = ArtCamGetWidth(Number);
		LONG Height = ArtCamGetHeight(Number);
		LONG Bpp = ArtCamGetBpp(Number);

		BITMAPINFO2 bm;
		bm.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bm.bmiHeader.biPlanes = 1;
		bm.bmiHeader.biCompression = BI_RGB;
		bm.bmiHeader.biSizeImage = 0;
		bm.bmiHeader.biXPelsPerMeter = 0;
		bm.bmiHeader.biYPelsPerMeter = 0;
		bm.bmiHeader.biClrUsed = 0;
		bm.bmiHeader.biClrImportant = 0;

		bm.bmiHeader.biWidth = Width;
		bm.bmiHeader.biHeight = Height;


		RECT rc;
		GetClientRect(hWnd, &rc);
		rc.right = rc.right < Width*2 ? rc.right : Width*2;

		rc.left   = 0 + (rc.right/2) * Number;
		rc.top    = 0;
		rc.right  = rc.right / 2;
		rc.bottom = Height;

		UINT Line = Height;



		// mNWrbg摜]
		if(1 == Bpp){
			bm.bmiHeader.biBitCount = 8;

			for(int i=0; i<256; i++){
				bm.bmiColors[i].rgbRed = i;
				bm.bmiColors[i].rgbGreen = i;
				bm.bmiColors[i].rgbBlue = i;
				bm.bmiColors[i].rgbReserved = 0;
			}
			::SetDIBColorTable(hDC, 0, 256, bm.bmiColors);

			SetDIBitsToDevice(hDC, rc.left, rc.top, rc.right, rc.bottom, 0, 0, 0, Line, pImage, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
		}

		// mNPOrbg^PUrbg摜]
		else if(2 == Bpp){
			bm.bmiHeader.biBitCount = 8;

			for(int i=0; i<256; i++){
				bm.bmiColors[i].rgbRed = i;
				bm.bmiColors[i].rgbGreen = i;
				bm.bmiColors[i].rgbBlue = i;
				bm.bmiColors[i].rgbReserved = 0;
			}
			::SetDIBColorTable(hDC, 0, 256, bm.bmiColors);

			LPBYTE pTemp = new BYTE[bm.bmiHeader.biWidth * bm.bmiHeader.biHeight];
			if(pTemp){
				for(int y=0; y<bm.bmiHeader.biHeight; y++){

					LPBYTE pDest =        pTemp   + (y * bm.bmiHeader.biWidth);
					LPWORD pSrc  = LPWORD(pImage) + (y * bm.bmiHeader.biWidth);

					for(int x=0; x<bm.bmiHeader.biWidth; x++){
						pDest[0] = BYTE(pSrc[0] >> 2);

						pDest++;
						pSrc ++;
					}
				}


				SetDIBitsToDevice(hDC, rc.left, rc.top, rc.right, rc.bottom, 0, 0, 0, Line, pTemp, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
				delete[] pTemp;
			}
		}

		// J[QSrbg]
		else if(3 == Bpp){
			bm.bmiHeader.biBitCount = 24;
			SetDIBitsToDevice(hDC, rc.left, rc.top, rc.right, rc.bottom, 0, 0, 0, Line, pImage, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
		}

		// J[RQrbg]
		else if(4 == Bpp){
			bm.bmiHeader.biBitCount = 24;

			LPBYTE pTemp = new BYTE[bm.bmiHeader.biWidth * bm.bmiHeader.biHeight * 3];
			if(pTemp){
				for(int y=0; y<bm.bmiHeader.biHeight; y++){

					LPBYTE pDest = pTemp    + (y * bm.bmiHeader.biWidth * 3);
					LPBYTE pSrc  = pImage + (y * bm.bmiHeader.biWidth * 4);

					for(int x=0; x<bm.bmiHeader.biWidth; x++){
						pDest[0] = pSrc[0];
						pDest[1] = pSrc[1];
						pDest[2] = pSrc[2];

						pDest+=3;
						pSrc +=4;
					}
				}


				SetDIBitsToDevice(hDC, rc.left, rc.top, rc.right, rc.bottom, 0, 0, 0, Line, pTemp, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
				delete[] pTemp;
			}
		}

		// J[SWAUSrbg]
		else if(6 == Bpp || 8 == Bpp){
			bm.bmiHeader.biBitCount = 24;
			Bpp /= 2;

			LPBYTE pTemp = new BYTE[bm.bmiHeader.biWidth * bm.bmiHeader.biHeight * 3];
			if(pTemp){
				for(int y=0; y<bm.bmiHeader.biHeight; y++){

					LPBYTE pDest =        pTemp     + (y * bm.bmiHeader.biWidth * 3);
					LPWORD pSrc  = LPWORD(pImage) + (y * bm.bmiHeader.biWidth * Bpp);

					for(int x=0; x<bm.bmiHeader.biWidth; x++){
						pDest[0] = BYTE(pSrc[0] >> 2);
						pDest[1] = BYTE(pSrc[1] >> 2);
						pDest[2] = BYTE(pSrc[2] >> 2);

						pDest+=3;
						pSrc +=Bpp;
					}
				}


				SetDIBitsToDevice(hDC, rc.left, rc.top, rc.right, rc.bottom, 0, 0, 0, Line, pTemp, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
				delete[] pTemp;
			}
		}


		if(Flg){
			ReleaseDC(hWnd, hDC);
		}

		return 1;
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	rcjŕ`
//

BOOL OnPreview(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}

	// ^C}[폜
	if(3 == g_Preview){
		KillTimer(hWnd, TIMER_ID);
	}


	// ňUfoCXJ
	g_CArtCamSdk[0].Close();
	g_CArtCamSdk[1].Close();


	// fp̗̈J
	SAFE_DELETE(g_pImage[0]);
	SAFE_DELETE(g_pImage[1]);


	// \EBhEݒ肷
	// hWnd NULLݒ肷ƐVEBhE쐬ĕ\܂
	RECT rc;
	GetClientRect(hWnd, &rc);
	g_CArtCamSdk[0].SetPreviewWindow(hWnd, 0, 0, rc.right/2, rc.bottom);
	g_CArtCamSdk[1].SetPreviewWindow(hWnd, rc.right/2, 0, rc.right, rc.bottom);


	// f\
	g_CArtCamSdk[0].Preview();
	g_CArtCamSdk[1].Preview();


	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_CHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_UNCHECKED);

	g_Preview = 0;

	InvalidateRect(hWnd, NULL, TRUE);

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	f̃|C^擾ăAvP[Vŕ`悷
//

BOOL OnCallBack(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}

	// ^C}[폜
	if(3 == g_Preview){
		KillTimer(hWnd, TIMER_ID);
	}


	// ňUfoCXJ
	g_CArtCamSdk[0].Close();
	g_CArtCamSdk[1].Close();


	// fp̗̈J
	SAFE_DELETE(g_pImage[0]);
	SAFE_DELETE(g_pImage[1]);


	// ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
	// CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
	g_CArtCamSdk[0].SetPreviewWindow(hWnd, 0, 0, 0, 0);
	g_CArtCamSdk[1].SetPreviewWindow(hWnd, 0, 0, 0, 0);


	// 荞ݗp̈m
	g_pImage[0] = new BYTE[ArtCamGetSize(0)];
	g_pImage[1] = new BYTE[ArtCamGetSize(1)];

	g_CArtCamSdk[0].CallBackPreview(hWnd, g_pImage[0], ArtCamGetSize(0), 0);
	g_CArtCamSdk[1].CallBackPreview(hWnd, g_pImage[1], ArtCamGetSize(1), 0);


	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_CHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_UNCHECKED);

	g_Preview = 1;

	InvalidateRect(hWnd, NULL, TRUE);

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	ꖇ摜\
//

BOOL OnSnapShot(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}

	// ^C}[폜
	if(3 == g_Preview){
		KillTimer(hWnd, TIMER_ID);
	}


	// ňUfoCXJ
	g_CArtCamSdk[0].Close();
	g_CArtCamSdk[1].Close();


	// fp̗̈J
	SAFE_DELETE(g_pImage[0]);
	SAFE_DELETE(g_pImage[1]);


	// 荞ݗp̈m
	g_pImage[0] = new BYTE[ArtCamGetSize(0)];
	g_pImage[1] = new BYTE[ArtCamGetSize(1)];

	g_CArtCamSdk[0].SnapShot(g_pImage[0], ArtCamGetSize(0), 0);
	g_CArtCamSdk[1].SnapShot(g_pImage[1], ArtCamGetSize(1), 0);


	// 摜`
	DrawImage(hWnd, NULL, 0);
	DrawImage(hWnd, NULL, 1);

	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_UNCHECKED);

	g_Preview = -1;

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	rcjŕ`
//

LRESULT OnCapture(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}


	// ňUfoCXJ
	g_CArtCamSdk[0].Close();
	g_CArtCamSdk[1].Close();


	// fp̗̈J
	SAFE_DELETE(g_pImage[0]);
	SAFE_DELETE(g_pImage[1]);

	// 荞ݗp̈m
	g_pImage[0] = new BYTE[ArtCamGetSize(0)];
	g_pImage[1] = new BYTE[ArtCamGetSize(1)];

	g_CArtCamSdk[0].Capture();
	g_CArtCamSdk[1].Capture();


	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_CHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_UNCHECKED);

	g_Preview = 3;

	SetTimer(hWnd, TIMER_ID, TIMER_TIME, NULL);

	return TRUE;
}


LRESULT OnTimer(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if(3 == g_Preview && TIMER_ID == wParam){
		KillTimer(hWnd, TIMER_ID);

		g_CArtCamSdk[0].SnapShot(g_pImage[0], ArtCamGetSize(0), 0);
		g_CArtCamSdk[1].SnapShot(g_pImage[1], ArtCamGetSize(1), 0);

		// 摜`
		DrawImage(hWnd, NULL, 0);
		DrawImage(hWnd, NULL, 1);

		SetTimer(hWnd, TIMER_ID, TIMER_TIME, NULL);

		return 1;
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	gK[[h
//

BOOL OnTrigger(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}

	// ^C}[폜
	if(3 == g_Preview){
		KillTimer(hWnd, TIMER_ID);
	}


	// ňUfoCXJ
	g_CArtCamSdk[0].Close();
	g_CArtCamSdk[1].Close();


	// fp̗̈J
	SAFE_DELETE(g_pImage[0]);
	SAFE_DELETE(g_pImage[1]);


	// ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
	// CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
	g_CArtCamSdk[0].SetPreviewWindow(hWnd, 0, 0, 0, 0);
	g_CArtCamSdk[1].SetPreviewWindow(hWnd, 0, 0, 0, 0);


	// 荞ݗp̈m
	g_pImage[0] = new BYTE[ArtCamGetSize(0)];
	g_pImage[1] = new BYTE[ArtCamGetSize(1)];

	g_CArtCamSdk[0].Trigger(hWnd, g_pImage[0], ArtCamGetSize(0), 0);
	g_CArtCamSdk[1].Trigger(hWnd, g_pImage[1], ArtCamGetSize(1), 0);


	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_CHECKED);

	g_Preview = 4;

	InvalidateRect(hWnd, NULL, TRUE);

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	DLL؂ւ
//

BOOL OnDllChange(HWND hWnd, LONG DllType, LONG CameraType)
{
	// ckk؂ւۂ͈USĊJ܂B
	// ̃J̓\sۂ CArtCamSdk 𕡐`Kv܂B
	g_CArtCamSdk[0].Release();
	g_CArtCamSdk[1].Release();
	g_CArtCamSdk[0].FreeLibrary();
	g_CArtCamSdk[1].FreeLibrary();


	if(!g_CArtCamSdk[0].LoadLibrary(const_cast<LPTSTR>(DLLNAMELIST[DllType]))){
		TCHAR Error[256]="";
		wsprintf(Error, "%s܂\nNDLLړ\܂", DLLNAMELIST[DllType]);
		MessageBox(hWnd, Error, "G[", MB_OK);
		return FALSE;
	}
	if(!g_CArtCamSdk[1].LoadLibrary(const_cast<LPTSTR>(DLLNAMELIST[DllType]))){
		TCHAR Error[256]="";
		wsprintf(Error, "%s܂\nNDLLړ\܂", DLLNAMELIST[DllType]);
		MessageBox(hWnd, Error, "G[", MB_OK);
		return FALSE;
	}

	// QJɕ\ۂ
	// Initialize -> SetDeviceNumber ̗KŏɂĂB
	// PJāA\ɂQJڂ悤Ƃ
	// PJɉeł\܂B
	if(!g_CArtCamSdk[0].Initialize(hWnd)){
		MessageBox(hWnd, "rcj̏Ɏs܂", "G[", MB_OK);
		return FALSE;
	}
	if(!g_CArtCamSdk[1].Initialize(hWnd)){
		MessageBox(hWnd, "rcj̏Ɏs܂", "G[", MB_OK);
		return FALSE;
	}


	// 
	if(-1 != CameraType && ARTCAM_CAMERATYPE_SATA == HIWORD(g_CArtCamSdk[0].GetDllVersion())){
		g_CArtCamSdk[0].SetCameraType(CameraType);
	}
	if(-1 != CameraType && ARTCAM_CAMERATYPE_SATA == HIWORD(g_CArtCamSdk[1].GetDllVersion())){
		g_CArtCamSdk[1].SetCameraType(CameraType);
	}


	// foCXڑĂ邩ǂ́AfoCX擾Ε
	TCHAR szDeviceName[256]="";
	if(!g_CArtCamSdk[0].GetDeviceName(0, szDeviceName, 256)){
		g_CArtCamSdk[0].FreeLibrary();
	}
	if(!g_CArtCamSdk[1].GetDeviceName(1, szDeviceName, 256)){
		// foCXołȂ
		// foCXPołȂۂɂQ̃NXANZX
		// P̃foCXɓdANZXĂ܂̂Œ
		// NX邩A֐R[Ȃ悤ɂĂ

		// Ƃ肠NXJĂ܂Ί֐R[ĂSɎsB
		g_CArtCamSdk[1].FreeLibrary();
	}


	g_CArtCamSdk[0].SetDeviceNumber(0);
	g_CArtCamSdk[1].SetDeviceNumber(1);

	// QJ𓯎ɕ\ۂ͕Kn[tNbNɂĂ
	g_CArtCamSdk[0].SetHalfClock(TRUE);
	g_CArtCamSdk[1].SetHalfClock(TRUE);




	// j[`FbN
	for(int i=0; i<DLLCOUNT; i++){
		::CheckMenuItem(g_Menu.Dll, i, MF_BYPOSITION | MF_UNCHECKED);
	}

	::CheckMenuItem(g_Menu.Dll, DllType, MF_BYPOSITION | MF_CHECKED);


	// ݒEBhE̎gp\Ԃ̐؂ւ
	switch(DllType){
	// CNV
	case 3:
		::EnableMenuItem(g_Menu.Set, 0, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Set, 1, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Set, 2, MF_BYPOSITION | MF_GRAYED);
	break;

	// ̑
	default:
		::EnableMenuItem(g_Menu.Set, 0, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Set, 1, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Set, 2, MF_BYPOSITION | MF_ENABLED);
	break;
	}


	switch(g_Preview){
	case 0:	return OnPreview(hWnd);
	case 1:	return OnCallBack(hWnd);
	case 3:	return OnCapture(hWnd);
	case 4:	return OnTrigger(hWnd);
	}

	return FALSE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_CREATE
//

LRESULT OnCreate(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	TCHAR szFilePath[MAX_PATH]="";
	TCHAR szExePath[3][MAX_PATH]={"","",""};
	GetModuleFileName(::GetModuleHandle(NULL), szExePath[0], MAX_PATH);
	_splitpath_s(szExePath[0], szExePath[1],MAX_PATH, szExePath[2], MAX_PATH, NULL,0, NULL,0);
	wsprintf(szFilePath, "%s%sSample.ini", szExePath[1], szExePath[2]);

	g_DllType = ::GetPrivateProfileInt("Sample", "DllType", -1, szFilePath);
	g_CameraType = ::GetPrivateProfileInt("Sample", "CameraType", -1, szFilePath);

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_COMMAND
//

LRESULT OnCommand(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	switch (LOWORD(wParam)){
	// t@Cۑ
	case IDM_SAVE:
		g_CArtCamSdk[0].SaveImage("Image1.jpg", FILETYPE_JPEG_HIGH);
		g_CArtCamSdk[1].SaveImage("Image2.jpg", FILETYPE_JPEG_HIGH);
	return 1;

	// I
	case IDM_EXIT:
		::PostMessage(hWnd, WM_CLOSE, 0, 0);
	return 1;

	// rcjŕ`悷
	case IDM_PREVIEW:
		OnPreview(hWnd);
	return 1;

	// f̃|C^擾ĎOŕ`悷
	case IDM_CALLBACK:
		OnCallBack(hWnd);
	return 1;

	// fP擾
	case IDM_SNAPSHOT:
		OnSnapShot(hWnd);
	return 1;

	// AŃXibvVbgB
	case IDM_CAPTURE:
		OnCapture(hWnd);
	return 1;

	// gK[[h
	case IDM_TRIGGER:
		OnTrigger(hWnd);
	return 1;

	// Jݒ
	case IDM_FORMAT1:
		// Jݒ_CAO\ۂ͕\͈U鎖𐄏܂
		// \AvP[VŒ~ȂƂrcjŉfXV͒~܂B
		// rcjŒ~ꍇ̓_CAO_ōĊJ܂A
		// ̍ېݒύXāA_CAOꍇ̓AvP[V̐ݒ𔽉fȂ
		// šɂȂ\܂B
		if(3 == g_Preview)	KillTimer(hWnd, TIMER_ID);

		g_CArtCamSdk[0].Close();
		g_CArtCamSdk[1].Close();
		g_CArtCamSdk[0].SetCameraDlg(hWnd);

		switch(g_Preview){
		case 0:	return OnPreview(hWnd);
		case 1:	return OnCallBack(hWnd);
		case 3:	return OnCapture(hWnd);
		case 4:	return OnTrigger(hWnd);
		}
	return 1;

	case IDM_FORMAT2:
		// Jݒ_CAO\ۂ͕\͈U鎖𐄏܂
		// \AvP[VŒ~ȂƂrcjŉfXV͒~܂B
		// rcjŒ~ꍇ̓_CAO_ōĊJ܂A
		// ̍ېݒύXāA_CAOꍇ̓AvP[V̐ݒ𔽉fȂ
		// šɂȂ\܂B
		if(3 == g_Preview)	KillTimer(hWnd, TIMER_ID);

		g_CArtCamSdk[0].Close();
		g_CArtCamSdk[1].Close();
		g_CArtCamSdk[1].SetCameraDlg(hWnd);

		switch(g_Preview){
		case 0:	return OnPreview(hWnd);
		case 1:	return OnCallBack(hWnd);
		case 3:	return OnCapture(hWnd);
		case 4:	return OnTrigger(hWnd);
		}
	return 1;

	// tB^[ݒ
	case IDM_FILTER1:
		g_CArtCamSdk[0].SetImageDlg(hWnd);
	return 1;

	case IDM_FILTER2:
		g_CArtCamSdk[1].SetImageDlg(hWnd);
	return 1;

	// AiOݒ
	case IDM_ANALOG1:
		g_CArtCamSdk[0].SetAnalogDlg(hWnd);
	return 1;

	case IDM_ANALOG2:
		g_CArtCamSdk[1].SetAnalogDlg(hWnd);
	return 1;

	// DLL؂ւ
	case IDM_CAM:		g_DllType =  0;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_USTC:		g_DllType =  2;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_CNV:		g_DllType =  3;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_130MI:		g_DllType =  5;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_200MI:		g_DllType =  6;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_300MI:		g_DllType =  7;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_150P:		g_DllType =  8;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_320P:		g_DllType =  9;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_200SH:		g_DllType = 10;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_098:		g_DllType = 11;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_036MI:		g_DllType = 12;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_500P:		g_DllType = 13;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_150P2:		g_DllType = 14;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_500MI:		g_DllType = 15;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_T111:		g_DllType = 16;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_T112:		g_DllType = 17;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_150P3:		g_DllType = 18;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_130MIV:	g_DllType = 19;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_150P3V:	g_DllType = 20;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_267KY:		g_DllType = 21;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_274KY:		g_DllType = 22;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
        case IDM_625KY:		g_DllType = 23;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
        case IDM_V135MI:	g_DllType = 24;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
        case IDM_445KY:		g_DllType = 28;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
        case IDM_098II:		g_DllType = 29;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
        case IDM_MV413:		g_DllType = 30;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
        case IDM_OV210:		g_DllType = 31;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
        case IDM_850SH:		g_DllType = 32;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
        case IDM_1251SH:	g_DllType = 33;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
        case IDM_D131:  	g_DllType = 34;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_900MI:     g_DllType = 35; g_CameraType = -1;  OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_1000MI:    g_DllType = 36; g_CameraType = -1;  OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_500P2:	    g_DllType = 37; g_CameraType = -1;  OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_LVDS:	g_DllType = 26;	g_CameraType = 0;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_300MI:	g_DllType = 26;	g_CameraType = 1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_500MI:	g_DllType = 26;	g_CameraType = 2;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_MV413:	g_DllType = 26;	g_CameraType = 3;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_800MI:	g_DllType = 26;	g_CameraType = 4;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_036MI:	g_DllType = 26;	g_CameraType = 5;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_150P3:	g_DllType = 26;	g_CameraType = 6;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_267KY:	g_DllType = 26;	g_CameraType = 6;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_274KY:	g_DllType = 26;	g_CameraType = 7;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_625KY:	g_DllType = 26;	g_CameraType = 8;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_130MI:	g_DllType = 26;	g_CameraType = 9;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_200MI:	g_DllType = 26;	g_CameraType =10;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_PAINT
//

LRESULT OnPaint(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT psPaint;
	HDC hDC = BeginPaint(hWnd, &psPaint);
	if(hDC){
		DrawImage(hWnd, hDC, 0);
		DrawImage(hWnd, hDC, 1);
		EndPaint(hWnd, &psPaint);
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_ERROR
//

LRESULT OnError(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if(0 <= lParam && lParam < ERRORCOUNT-1){
		SetWindowText(hWnd, ERRORLIST[lParam]);
	}
	else {
		// s̃G[
		SetWindowText(hWnd, ERRORLIST[ARTCAMSDK_UNKNOWN]);
	}

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_GRAPHPAINT
//

LRESULT OnGraphPaint(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if(NULL == wParam){
		return OnError(hWnd, wParam, lParam);
	}


	// ̃bZ[W_ g_pImage ɂ͍ŐV̉fi[Ă
	LPGP_INFO pGpInfo = (LPGP_INFO)wParam;
	DrawImage(hWnd, NULL, 0);
	DrawImage(hWnd, NULL, 1);


	TCHAR Fps[256]="";
	sprintf_s(Fps,256, "Tv  %.1f t[", double(pGpInfo->lFps) / 10.0);
	SetWindowText(hWnd, Fps);

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_DESTROY
//

LRESULT OnDestroy(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	// Release ̓J̎gpIƂɌĂяo܂ifXgN^łĂ΂܂j
	// Release ɍēxJgpꍇ Initialize ĂԕKv܂
	g_CArtCamSdk[0].Release();
	g_CArtCamSdk[1].Release();
	SAFE_DELETE(g_pImage[0]);
	SAFE_DELETE(g_pImage[1]);


	TCHAR szFilePath[MAX_PATH]="";
	TCHAR szExePath[3][MAX_PATH]={"","",""};
	GetModuleFileName(::GetModuleHandle(NULL), szExePath[0], MAX_PATH);
	_splitpath_s(szExePath[0], szExePath[1],MAX_PATH , szExePath[2],MAX_PATH, NULL,0, NULL,0);
	wsprintf(szFilePath, "%s%sSample.ini", szExePath[1], szExePath[2]);


	TCHAR Data[32]="";
	wsprintf(Data, "%d", g_DllType);
	::WritePrivateProfileString("Sample", "DllType", Data, szFilePath);

	wsprintf(Data, "%d", g_CameraType);
	::WritePrivateProfileString("Sample", "CameraType", Data, szFilePath);


	::PostQuitMessage(0);
	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_SIZE
//

HWND ChildList[2] = {NULL, NULL};

static BOOL CALLBACK EnumChildProc(HWND hWnd, LPARAM lParam)
{
	for(int i=0; i<2; i++){
		if(NULL == ChildList[i]){
			ChildList[i] = hWnd;
			break;
		}
	}

	return 1;
}

LRESULT OnSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if(0 == g_Preview){
		ChildList[0] = NULL;
		ChildList[1] = NULL;

		// qEBhE
		::LockWindowUpdate(hWnd);
		::EnumChildWindows(hWnd, ::EnumChildProc, NULL);
		::LockWindowUpdate(NULL);

		RECT rc;
		GetClientRect(hWnd, &rc);

		LONG Width[2]  = { rc.right/2, rc.right/2 };
		LONG Height[2] = { rc.bottom, rc.bottom };


		// AXyNgςȂꍇ͂̃̕RgOĂ
/*
		// vZ͏PʂɂȂ̂ňU_^ɂĂ܂
		for(int i=0; i<2; i++){
			double winW = rc.right/2;
			double winH = rc.bottom;
			double capW = ArtCamGetWidth(i);
			double capH = ArtCamGetHeight(i);

			if( (winW * capH) > (winH * capW) ){
				winW = winH * capW / capH;
				Width[i] = LONG(winW);
			}
			else if( (winW * capH) < (winH * capW) ){
				winH = winW * capH / capW;
				Height[i] = LONG(winH);
			}
		}
*/
		SetWindowPos(ChildList[0], HWND_TOP,          0, 0, Width[0], Height[0], SWP_NOZORDER | SWP_SHOWWINDOW);
		SetWindowPos(ChildList[1], HWND_TOP, rc.right/2, 0, Width[0], Height[0], SWP_NOZORDER | SWP_SHOWWINDOW);
	}

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	EBhEvV[W
//

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_CREATE:		return OnCreate			(hWnd, wParam, lParam);
	case WM_COMMAND:	return OnCommand		(hWnd, wParam, lParam);
	case WM_PAINT:		return OnPaint			(hWnd, wParam, lParam);
	case WM_GRAPHPAINT:	return OnGraphPaint		(hWnd, wParam, lParam);
	case WM_ERROR:		return OnError			(hWnd, wParam, lParam);
	case WM_DESTROY:	return OnDestroy		(hWnd, wParam, lParam);
	case WM_SIZE:		return OnSize			(hWnd, wParam, lParam);
	case WM_TIMER:		return OnTimer			(hWnd, wParam, lParam);
	default:			return ::DefWindowProc	(hWnd, uMsg, wParam, lParam);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	EBhE
//

HWND InitWindow(HINSTANCE hInstance, int nCmdShow)
{
	// EBhENXo^
	WNDCLASSEX wndclassex;
	ZeroMemory(&wndclassex,		sizeof(wndclassex));
	wndclassex.cbSize			= sizeof(wndclassex);
	wndclassex.style			= 0;
	wndclassex.lpfnWndProc		= WndProc;
	wndclassex.cbClsExtra		= 0;
	wndclassex.cbWndExtra		= 0;
	wndclassex.hInstance		= hInstance;
	wndclassex.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wndclassex.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wndclassex.hbrBackground	= reinterpret_cast<HBRUSH>(::GetStockObject(BLACK_BRUSH));
	wndclassex.lpszClassName	= "Tv";
	wndclassex.lpszMenuName		= 0;
	wndclassex.hIconSm			= NULL;

	if(0 == ::RegisterClassEx(&wndclassex))
		return NULL;

	// EBhETCYݒ
	RECT rcWndSize = {0, 0, 900, 600};
	DWORD dwStyle = WS_POPUPWINDOW | WS_CAPTION | WS_OVERLAPPEDWINDOW;
	if(0 == ::AdjustWindowRectEx(&rcWndSize, dwStyle, TRUE, NULL))
		return NULL;

	// CEBhE
	HWND hWnd = ::CreateWindowEx(NULL, "Tv", "Tv", dwStyle,
			(::GetSystemMetrics(SM_CXSCREEN) - (rcWndSize.right - rcWndSize.left)) / 2,
			(::GetSystemMetrics(SM_CYSCREEN) - (rcWndSize.bottom - rcWndSize.top)) / 2,
			rcWndSize.right - rcWndSize.left, rcWndSize.bottom - rcWndSize.top,
			HWND_DESKTOP, NULL, hInstance, NULL);

	if(NULL == hWnd)
		return NULL;


	// j[쐬

	// t@Cj[
	g_Menu.File = ::CreateMenu();
	::InsertMenu(g_Menu.File, 0, MF_BYPOSITION | MF_STRING, IDM_SAVE, "ۑ(&S)");
	::InsertMenu(g_Menu.File, 1, MF_BYPOSITION | MF_STRING, IDM_EXIT, "I(&X)");

	// \j[
	g_Menu.Preview = ::CreateMenu();
	::InsertMenu(g_Menu.Preview, 0, MF_BYPOSITION | MF_STRING, IDM_PREVIEW, "vr[(&P)");
	::InsertMenu(g_Menu.Preview, 1, MF_BYPOSITION | MF_STRING, IDM_CALLBACK, "R[obN(&B)");
	::InsertMenu(g_Menu.Preview, 2, MF_BYPOSITION | MF_STRING, IDM_SNAPSHOT, "XibvVbg(&S)");
	::InsertMenu(g_Menu.Preview, 3, MF_BYPOSITION | MF_STRING, IDM_CAPTURE, "Lv`(&C)");
	::InsertMenu(g_Menu.Preview, 4, MF_BYPOSITION | MF_STRING, IDM_TRIGGER, "gK[(&T)");

	// ݒ胁j[
	g_Menu.Set = ::CreateMenu();
	::InsertMenu(g_Menu.Set, 0, MF_BYPOSITION | MF_STRING, IDM_FORMAT1, "tH[}bgݒ1(&C)");
	::InsertMenu(g_Menu.Set, 1, MF_BYPOSITION | MF_STRING, IDM_FORMAT2, "tH[}bgݒ2(&C)");
	::InsertMenu(g_Menu.Set, 2, MF_BYPOSITION | MF_STRING, IDM_FILTER1, "tB^[ݒ1(&F)");
	::InsertMenu(g_Menu.Set, 3, MF_BYPOSITION | MF_STRING, IDM_FILTER2, "tB^[ݒ2(&F)");
	::InsertMenu(g_Menu.Set, 4, MF_BYPOSITION | MF_STRING, IDM_ANALOG1, "AiOݒ1(&A)");
	::InsertMenu(g_Menu.Set, 5, MF_BYPOSITION | MF_STRING, IDM_ANALOG2, "AiOݒ2(&A)");

	// DLLIj[
	g_Menu.Dll = ::CreateMenu();
	::InsertMenu(g_Menu.Dll,  0, MF_BYPOSITION | MF_STRING, IDM_CAM,   "DirectShow Camera");
	::InsertMenu(g_Menu.Dll,  1, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL );
	::InsertMenu(g_Menu.Dll,  2, MF_BYPOSITION | MF_STRING, IDM_USTC,  "ARTUST");
	::InsertMenu(g_Menu.Dll,  3, MF_BYPOSITION | MF_STRING, IDM_CNV,   "ARTCNV");
	::InsertMenu(g_Menu.Dll,  4, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL );
	::InsertMenu(g_Menu.Dll,  5, MF_BYPOSITION | MF_STRING, IDM_130MI, "ARTCAM-130MI");
	::InsertMenu(g_Menu.Dll,  6, MF_BYPOSITION | MF_STRING, IDM_200MI, "ARTCAM-200MI");
	::InsertMenu(g_Menu.Dll,  7, MF_BYPOSITION | MF_STRING, IDM_300MI, "ARTCAM-300MI");
	::InsertMenu(g_Menu.Dll,  8, MF_BYPOSITION | MF_STRING, IDM_150P,  "ARTCAM-150P");
	::InsertMenu(g_Menu.Dll,  9, MF_BYPOSITION | MF_STRING, IDM_320P,  "ARTCAM-320P");
	::InsertMenu(g_Menu.Dll, 10, MF_BYPOSITION | MF_STRING, IDM_200SH, "ARTCAM-200SH");
	::InsertMenu(g_Menu.Dll, 11, MF_BYPOSITION | MF_STRING, IDM_098,   "ARTCAM-098");
	::InsertMenu(g_Menu.Dll, 12, MF_BYPOSITION | MF_STRING, IDM_036MI, "ARTCAM-036MI");
	::InsertMenu(g_Menu.Dll, 13, MF_BYPOSITION | MF_STRING, IDM_500P,  "ARTCAM-500P");
	::InsertMenu(g_Menu.Dll, 14, MF_BYPOSITION | MF_STRING, IDM_150P2,  "ARTCAM-150P2");
	::InsertMenu(g_Menu.Dll, 15, MF_BYPOSITION | MF_STRING, IDM_500MI,  "ARTCAM-500MI");
	::InsertMenu(g_Menu.Dll, 16, MF_BYPOSITION | MF_STRING, IDM_T111,  "ARTCAM-T111");
	::InsertMenu(g_Menu.Dll, 17, MF_BYPOSITION | MF_STRING, IDM_T112,  "ARTCAM-T112");
	::InsertMenu(g_Menu.Dll, 18, MF_BYPOSITION | MF_STRING, IDM_150P3,  "ARTCAM-150P3");
	::InsertMenu(g_Menu.Dll, 19, MF_BYPOSITION | MF_STRING, IDM_130MIV,  "ARTCAM-130MI MOUT");
	::InsertMenu(g_Menu.Dll, 20, MF_BYPOSITION | MF_STRING, IDM_150P3V,  "ARTCAM-150P3 MOUT");
	::InsertMenu(g_Menu.Dll, 21, MF_BYPOSITION | MF_STRING, IDM_267KY,  "ARTCAM-267KY");
	::InsertMenu(g_Menu.Dll, 22, MF_BYPOSITION | MF_STRING, IDM_274KY,  "ARTCAM-274KY");
	::InsertMenu(g_Menu.Dll, 23, MF_BYPOSITION | MF_STRING, IDM_625KY,  "ARTCAM-625KY");
	::InsertMenu(g_Menu.Dll, 24, MF_BYPOSITION | MF_STRING, IDM_V135MI,  "ARTCAM-V135MI");
	::InsertMenu(g_Menu.Dll, 25, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL );
        ::InsertMenu(g_Menu.Dll, 27, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL );
	::InsertMenu(g_Menu.Dll, 28, MF_BYPOSITION | MF_STRING, IDM_445KY,  "ARTCAM-445KY");
	::InsertMenu(g_Menu.Dll, 29, MF_BYPOSITION | MF_STRING, IDM_098II,  "ARTCAM-098II");
	::InsertMenu(g_Menu.Dll, 30, MF_BYPOSITION | MF_STRING, IDM_MV413,  "ARTCAM-MV413");
	::InsertMenu(g_Menu.Dll, 31, MF_BYPOSITION | MF_STRING, IDM_OV210,  "ARTCAM-OV210");
	::InsertMenu(g_Menu.Dll, 32, MF_BYPOSITION | MF_STRING, IDM_850SH,  "ARTCAM-850SH");
	::InsertMenu(g_Menu.Dll, 33, MF_BYPOSITION | MF_STRING, IDM_1251SH,  "ARTCAM-1251SH");
	::InsertMenu(g_Menu.Dll, 34, MF_BYPOSITION | MF_STRING, IDM_D131,  "ARTCAM-D131");
    ::InsertMenu(g_Menu.Dll, 35, MF_BYPOSITION | MF_STRING, IDM_900MI,	"ARTCAM-900MI");
    ::InsertMenu(g_Menu.Dll, 36, MF_BYPOSITION | MF_STRING, IDM_1000MI,	"ARTCAM-1000MI");
    ::InsertMenu(g_Menu.Dll, 37, MF_BYPOSITION | MF_STRING, IDM_500P2,	"ARTCAM-500P2");

	// SATA J
	HMENU MenuSata = ::CreateMenu();
	::InsertMenu(MenuSata, 0, MF_BYPOSITION | MF_STRING, IDM_SATA_LVDS,   "LVDS");
	::InsertMenu(MenuSata, 1, MF_BYPOSITION | MF_STRING, IDM_SATA_300MI,  "300MI");
	::InsertMenu(MenuSata, 2, MF_BYPOSITION | MF_STRING, IDM_SATA_500MI,  "500MI");
	::InsertMenu(MenuSata, 3, MF_BYPOSITION | MF_STRING, IDM_SATA_MV413,  "MV413");
	::InsertMenu(MenuSata, 4, MF_BYPOSITION | MF_STRING, IDM_SATA_800MI,  "800MI");
	::InsertMenu(MenuSata, 5, MF_BYPOSITION | MF_STRING, IDM_SATA_036MI,  "036MI");
	::InsertMenu(MenuSata, 6, MF_BYPOSITION | MF_STRING, IDM_SATA_150P3,  "150P3");
	::InsertMenu(MenuSata, 7, MF_BYPOSITION | MF_STRING, IDM_SATA_267KY,  "267KY");
	::InsertMenu(MenuSata, 8, MF_BYPOSITION | MF_STRING, IDM_SATA_274KY,  "274KY");
	::InsertMenu(MenuSata, 9, MF_BYPOSITION | MF_STRING, IDM_SATA_625KY,  "625KY");
	::InsertMenu(MenuSata,10, MF_BYPOSITION | MF_STRING, IDM_SATA_130MI,  "130MI");
	::InsertMenu(MenuSata,11, MF_BYPOSITION | MF_STRING, IDM_SATA_200MI,  "200MI");
	::InsertMenu(g_Menu.Dll, 26, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT_PTR)MenuSata,  "SATA");

	// DLL邩`FbN
	for(int i=0; i<DLLCOUNT; i++){
		CArtCamSdk ArtCam;
		if(!ArtCam.LoadLibrary(const_cast<LPTSTR>(DLLNAMELIST[i]))){
			::EnableMenuItem(g_Menu.Dll, i, MF_BYPOSITION | MF_GRAYED);
		}
	}

	// Cj[
	HMENU hMenu = ::CreateMenu();
	::InsertMenu(hMenu, 0, MF_POPUP | MF_STRING, (UINT)g_Menu.File,    "t@C(&F)");
	::InsertMenu(hMenu, 1, MF_POPUP | MF_STRING, (UINT)g_Menu.Preview, "\(&V)");
	::InsertMenu(hMenu, 2, MF_POPUP | MF_STRING, (UINT)g_Menu.Set,     "ݒ(&S)");
	::InsertMenu(hMenu, 3, MF_POPUP | MF_STRING, (UINT)g_Menu.Dll,     "ckk(&L)");


	::SetMenu(hWnd, hMenu);


	// tH[JX̐ݒ
	::SetFocus(hWnd);
	::ShowWindow(hWnd, nCmdShow);
	if(0 == ::UpdateWindow(hWnd))
		return NULL;

	// J̏
	if(-1 != g_DllType)
		OnDllChange(hWnd, g_DllType, g_CameraType);

	SetTimer(hWnd, 1, 100, NULL);
	return hWnd;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WinMain
//

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmLine, int nCmdShow)
{
	HWND hWnd = InitWindow(hInstance, nCmdShow);

	// bZ[W[v
	MSG msg;
	ZeroMemory(&msg, sizeof(msg));
	while(::GetMessage(&msg, NULL, 0, 0)){
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}

	return msg.wParam;
}



