//==========================================================
//	ARTRAY Camera / Capture Module Software Developer Kit
//						vr[^R[obN@\gpTv
//						VC++.NET Win32vWFNg
//
//									(C) 2002-2005 Artray
//==========================================================




//////////////////////////////////////////////////////////////////////////////////////////////
//
//	CN[ht@C
//

#include <windows.h>
#include <stdio.h>

// CuCN[h
#include "CArtCamSdk.hpp"
#include "CDib.h"


// e탁j[hc
enum {
	IDM_SAVE = WM_USER + 1,
	IDM_EXIT,

	IDM_PREVIEW,
	IDM_CALLBACK,
	IDM_SNAPSHOT,
	IDM_CAPTURE,
	IDM_TRIGGER,

	IDM_FORMAT,
	IDM_FILTER,
	IDM_ANALOG,

	IDM_CAM,
	IDM_USTC,
	IDM_CNV,
	IDM_130MI,
	IDM_200MI,
	IDM_300MI,
	IDM_150P,
	IDM_320P,
	IDM_200SH,
	IDM_098,
	IDM_036MI,
	IDM_500P,
	IDM_150P2,
	IDM_500MI,
	IDM_T111,
	IDM_T112,
	IDM_150P3,
	IDM_130MIV,
	IDM_150P3V,
	IDM_267KY,
	IDM_274KY,
	IDM_625KY,
	IDM_V135MI,
	IDM_SATA,
    IDM_445KY,
	IDM_098II,
	IDM_MV413,
	IDM_OV210,
	IDM_850SH,
	IDM_1251SH,
    IDM_D131,
	IDM_900MI,
	IDM_1000MI,
	IDM_500P2,

	IDM_SATA_LVDS,
	IDM_SATA_300MI,
	IDM_SATA_500MI,
	IDM_SATA_MV413,
	IDM_SATA_800MI,
	IDM_SATA_036MI,
	IDM_SATA_150P3,
	IDM_SATA_267KY,
	IDM_SATA_274KY,
	IDM_SATA_625KY,
	IDM_SATA_130MI,
	IDM_SATA_200MI,

	IDM_WIDEHI,
	IDM_WIDELOW,
	IDM_NORMALHI,
	IDM_NORMALLOW,
};



// WM_USER + 50 `@WM_USER + 59 ̓foCXݒpɗ\ς
#define IDM_DEVICE		WM_USER + 50


#define TIMER_ID	100
#define TIMER_TIME	50



CArtCamSdk	g_CArtCamSdk;
CDib		g_CDibCapture;		// Lv`[p̈
CDib		g_CDibView;			// \p̈iKQSrbgJ[j

BOOL		g_Preview = -1;			// vr[\^R[obN\
LONG		g_DllType = -1;			// ڑDLL
LONG		g_CameraType = -1;		// ڑJ
LONG		g_DeviceCount = 0;		// oꂽfoCX̐


const int SUB_SAMPLE[] = { 1, 2, 4, 8 };
#define ArtCamGetWidth()	(g_CArtCamSdk.Width()  / SUB_SAMPLE[g_CArtCamSdk.GetSubSample()])
#define ArtCamGetHeight()	(g_CArtCamSdk.Height() / SUB_SAMPLE[g_CArtCamSdk.GetSubSample()])
#define ArtCamGetColor()	WORD(((g_CArtCamSdk.GetColorMode() + 7) / 8) * 8)


struct SCROLL_CTRL{
	POINT	Pos;

	BOOL	MoveFlg;
	POINT	Start;
};

SCROLL_CTRL	g_ScrollCtrl;

struct MENU_LIST{
	HMENU	File;
	HMENU	Preview;
	HMENU	Set;
	HMENU	Dll;
	HMENU	Device;
	HMENU	Rate;
};

MENU_LIST g_Menu;



const TCHAR DLLNAMELIST[][32] = {
	"ArtCamSdk.dll",
	"",
	"ArtCamSdk_USTC.dll",
	"ArtCnvSdk.dll",
	"",
	"ArtCamSdk_130MI.dll",
	"ArtCamSdk_200MI.dll",
	"ArtCamSdk_300MI.dll",
	"ArtCamSdk_150P.dll",
	"ArtCamSdk_320P.dll",
	"ArtCamSdk_200SH.dll",
	"ArtCamSdk_098.dll",
	"ArtCamSdk_036MI.dll",
	"ArtCamSdk_500P.dll",
	"ArtCamSdk_150P2.dll",
	"ArtCamSdk_500MI.dll",
	"ArtCamSdk_T111.dll",
	"ArtCamSdk_T112.dll",
	"ArtCamSdk_150P3.dll",
	"ArtCamSdk_130MIV.dll",
	"ArtCamSdk_150P3V.dll",
	"ArtCamSdk_267KY.dll",
	"ArtCamSdk_274KY.dll",
    "ArtCamSdk_625KY.dll",
	"ArtCamSdk_V135MI.dll",
	"",
	"ArtCamSdk_SATA.dll",
	"",
	"ArtCamSdk_445KY.dll",
	"ArtCamSdk_098II.dll",
	"ArtCamSdk_MV413.dll",
	"ArtCamSdk_OV210.dll",
	"ArtCamSdk_850SH.dll",
	"ArtCamSdk_1251SH.dll",
	"ArtCamSdk_D131.dll",
	"ArtCamSdk_900MI.dll",
	"ArtCamSdk_1000MI.dll",
	"ArtCamSdk_500P2.dll",
};

const TCHAR ERRORLIST[][128] = {
	"",
	"Ă܂",
	"ps\ȃfoCXɃANZX悤Ƃ܂",
	"摜荞ݗpXbh쐬Ɏs",
	"EBhE쐬Ɏs",
	"C[W]ɏ\ȃmۂĂȂ@́@̊mۂɎs",
	"JifoCXj̐ݒŃG[",
	"JifoCXj̃TCYݒŃG[",
	"f荞݂Ŏs",
	"ԈĂ܂",
	"DirectShow G[",
	"̋@\̓T|[gĂ܂",
	"s̃G[",
	"foCX܂",
	"wt@C܂",
	"FPGA̐ݒŃG[",
};

const int DLLCOUNT = sizeof(DLLNAMELIST)/32;
const int ERRORCOUNT = sizeof(ERRORLIST)/128;

LONG DefProc = NULL;


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	XN[o[č\z
//

void ChangeScrollbar(HWND hWnd)
{
	if(0 == g_Preview){
		g_ScrollCtrl.Pos.x = 0;
		g_ScrollCtrl.Pos.y = 0;
		ShowScrollBar(hWnd, SB_HORZ, FALSE);
		ShowScrollBar(hWnd, SB_VERT, FALSE);
		return;
	}

	RECT rc;
	GetClientRect(hWnd, &rc);

	double dwScale = 1;

	LONG lWidth  = LONG(double(double(ArtCamGetWidth() ) * dwScale));
	LONG lHeight = LONG(double(double(ArtCamGetHeight()) * dwScale));

	LONG PosX = LONG(double(double(g_ScrollCtrl.Pos.x) * dwScale));
	LONG PosY = LONG(double(double(g_ScrollCtrl.Pos.y) * dwScale));


	SCROLLINFO sc;
	sc.fMask	= SIF_RANGE | SIF_POS | SIF_PAGE;

	LONG OffsetH = 16;
	LONG OffsetV = 16;


	if(rc.right + OffsetH >= lWidth){
		ShowScrollBar(hWnd, SB_HORZ, FALSE);
	} else {
		sc.nMin		= 0;
		sc.nMax		= lWidth;
		sc.nPage	= rc.right;
		sc.nPos		= PosX;
		SetScrollInfo(hWnd, SB_HORZ, &sc, TRUE);
	}

	if(rc.bottom + OffsetV >= lHeight){
		ShowScrollBar(hWnd, SB_VERT, FALSE);
	} else {
		sc.nMin		= 0;
		sc.nMax		= lHeight;
		sc.nPage	= rc.bottom;
		sc.nPos		= PosY;
		SetScrollInfo(hWnd, SB_VERT, &sc, TRUE);
	}


	double dwWidth  = double(ArtCamGetWidth ());
	double dwHeight = double(ArtCamGetHeight());

	if(dwWidth - (double(rc.right) / dwScale) < g_ScrollCtrl.Pos.x)
		g_ScrollCtrl.Pos.x = LONG(dwWidth - (double(rc.right) / dwScale));
	if(dwHeight - (double(rc.bottom) / dwScale) < g_ScrollCtrl.Pos.y)
		g_ScrollCtrl.Pos.y = LONG(dwHeight - (double(rc.bottom) / dwScale));
	if(0.0 > g_ScrollCtrl.Pos.x)
		g_ScrollCtrl.Pos.x = 0;
	if(0.0 > g_ScrollCtrl.Pos.y)
		g_ScrollCtrl.Pos.y = 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	摜`
//

LRESULT DrawImage(HWND hWnd, HDC hDC)
{
	BOOL Flg = FALSE;
	if(NULL == hDC){
		hDC = GetDC(hWnd);
		Flg = TRUE;
	}

	if(hDC){
		if(g_CDibView.GetImage()){
			// `p̈ɕϊ
			g_CDibView.Convert24Bit(&g_CDibCapture);

			POINT pt;
			GetCursorPos(&pt);
			ScreenToClient(hWnd, &pt);

			pt.x += g_ScrollCtrl.Pos.x;
			pt.y += g_ScrollCtrl.Pos.y;

			// J[\̈ʒuɏ\
			g_CDibView.MoveTo(0, pt.y);
			g_CDibView.LineTo(g_CDibView.GetWidth(), pt.y);
			g_CDibView.MoveTo(pt.x, 0);
			g_CDibView.LineTo(pt.x, g_CDibView.GetHeight());

			// J[\̍W\
			TCHAR szText[256];
			wsprintf(szText, "(%d, %d)", pt.x, pt.y);
			g_CDibView.TextOut(pt.x+10, pt.y+10, szText);


			// ʂɕ`
			::BitBlt(hDC, -g_ScrollCtrl.Pos.x, -g_ScrollCtrl.Pos.y, g_CDibView.GetWidth(), g_CDibView.GetHeight(),
							g_CDibView.GetDC(), 0, 0, SRCCOPY);
		}

		if(Flg){
			ReleaseDC(hWnd, hDC);
		}

		return 1;
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	rcjŕ`
//

BOOL OnPreview(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}

	// ^C}[폜
	if(3 == g_Preview){
		KillTimer(hWnd, TIMER_ID);
	}


	// ňUfoCXJ
	g_CArtCamSdk.Close();


	// fp̗̈J
	g_CDibCapture.Release();
	g_CDibView.Release();


	// \EBhEݒ肷
	// hWnd NULLݒ肷ƐVEBhE쐬ĕ\܂
	RECT rc;
	GetClientRect(hWnd, &rc);
	g_CArtCamSdk.SetPreviewWindow(hWnd, 0, 0, rc.right, rc.bottom);


	// f\
	g_CArtCamSdk.Preview();


	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_CHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_UNCHECKED);

	g_Preview = 0;

	ChangeScrollbar(hWnd);
	InvalidateRect(hWnd, NULL, TRUE);

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	f̃|C^擾ăAvP[Vŕ`悷
//

BOOL OnCallBack(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}

	// ^C}[폜
	if(3 == g_Preview){
		KillTimer(hWnd, TIMER_ID);
	}


	// ňUfoCXJ
	g_CArtCamSdk.Close();


	// fp̗̈J
	g_CDibCapture.Release();
	g_CDibView.Release();


	// ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
	// CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
	g_CArtCamSdk.SetPreviewWindow(hWnd, 0, 0, 0, 0);


	// 荞ݗp̈m
	g_CDibCapture.Create(NULL, ArtCamGetWidth(), ArtCamGetHeight(), ArtCamGetColor());

	// \p̈m
	g_CDibView.Create(NULL, ArtCamGetWidth(), ArtCamGetHeight(), 24);
	g_CDibView.SelectPen(PS_SOLID, 1, RGB(255,0,0));
	g_CDibView.SelectPointFont(14, "MS UI Gothic");
	g_CDibView.SetTextColor(RGB(255,0,0));
	g_CDibView.SetBkMode(TRANSPARENT);

	g_CArtCamSdk.CallBackPreview(hWnd, g_CDibCapture.GetImage(), g_CDibCapture.GetSize(), 0);


	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_CHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_UNCHECKED);

	g_Preview = 1;

	ChangeScrollbar(hWnd);
	InvalidateRect(hWnd, NULL, TRUE);

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	ꖇ摜\
//

BOOL OnSnapShot(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}

	// ^C}[폜
	if(3 == g_Preview){
		KillTimer(hWnd, TIMER_ID);
	}


	// ňUfoCXJ
	g_CArtCamSdk.Close();


	// fp̗̈J
	g_CDibCapture.Release();
	g_CDibView.Release();


	// 荞ݗp̈m
	g_CDibCapture.Create(NULL, ArtCamGetWidth(), ArtCamGetHeight(), ArtCamGetColor());

	// \p̈m
	g_CDibView.Create(NULL, ArtCamGetWidth(), ArtCamGetHeight(), 24);
	g_CDibView.SelectPen(PS_SOLID, 1, RGB(255,0,0));
	g_CDibView.SelectPointFont(14, "MS UI Gothic");
	g_CDibView.SetTextColor(RGB(255,0,0));
	g_CDibView.SetBkMode(TRANSPARENT);

	g_CArtCamSdk.SnapShot(g_CDibCapture.GetImage(), g_CDibCapture.GetSize(), 0);


	// 摜`
	DrawImage(hWnd, NULL);

	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_UNCHECKED);

	g_Preview = -1;

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	rcjŕ`
//

LRESULT OnCapture(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}


	// ňUfoCXJ
	g_CArtCamSdk.Close();


	// \EBhEݒ肷
	// hWnd NULLݒ肷ƐVEBhE쐬ĕ\܂
	RECT rc;
	GetClientRect(hWnd, &rc);
	g_CArtCamSdk.SetPreviewWindow(hWnd, 0, 0, rc.right, rc.bottom);


	// f\
	// \͂rcjŐ䂵܂̂ŉfɊւ͊{IɎ擾ł܂B
	g_CArtCamSdk.Capture();


	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_CHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_UNCHECKED);

	g_Preview = 3;


	// fp̗̈J
	g_CDibCapture.Release();
	g_CDibView.Release();


	// 荞ݗp̈m
	g_CDibCapture.Create(NULL, ArtCamGetWidth(), ArtCamGetHeight(), ArtCamGetColor());

	// \p̈m
	g_CDibView.Create(NULL, ArtCamGetWidth(), ArtCamGetHeight(), 24);
	g_CDibView.SelectPen(PS_SOLID, 1, RGB(255,0,0));
	g_CDibView.SelectPointFont(14, "MS UI Gothic");
	g_CDibView.SetTextColor(RGB(255,0,0));
	g_CDibView.SetBkMode(TRANSPARENT);

	SetTimer(hWnd, TIMER_ID, TIMER_TIME, NULL);

	return TRUE;
}


LRESULT OnTimer(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if(3 == g_Preview && TIMER_ID == wParam){
		KillTimer(hWnd, TIMER_ID);

		g_CArtCamSdk.SnapShot(g_CDibCapture.GetImage(), g_CDibCapture.GetSize(), 0);

		// 摜`
		DrawImage(hWnd, NULL);

		SetTimer(hWnd, TIMER_ID, TIMER_TIME, NULL);

		return 1;
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	gK[[h
//

BOOL OnTrigger(HWND hWnd)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}

	// ^C}[폜
	if(3 == g_Preview){
		KillTimer(hWnd, TIMER_ID);
	}


	// ňUfoCXJ
	g_CArtCamSdk.Close();


	// fp̗̈J
	g_CDibCapture.Release();
	g_CDibView.Release();


	// ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
	// CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
	g_CArtCamSdk.SetPreviewWindow(hWnd, 0, 0, 0, 0);


	// 荞ݗp̈m
	g_CDibCapture.Create(NULL, ArtCamGetWidth(), ArtCamGetHeight(), ArtCamGetColor());

	// \p̈m
	g_CDibView.Create(NULL, ArtCamGetWidth(), ArtCamGetHeight(), 24);
	g_CDibView.SelectPen(PS_SOLID, 1, RGB(255,0,0));
	g_CDibView.SelectPointFont(14, "MS UI Gothic");
	g_CDibView.SetTextColor(RGB(255,0,0));
	g_CDibView.SetBkMode(TRANSPARENT);

	g_CArtCamSdk.Trigger(hWnd, g_CDibCapture.GetImage(), g_CDibCapture.GetSize(), 0);


	// j[`FbN
	::CheckMenuItem(g_Menu.Preview, 0, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 1, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 3, MF_BYPOSITION | MF_UNCHECKED);
	::CheckMenuItem(g_Menu.Preview, 4, MF_BYPOSITION | MF_CHECKED);

	g_Preview = 4;

	ChangeScrollbar(hWnd);
	InvalidateRect(hWnd, NULL, TRUE);

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	DLL؂ւ
//

BOOL OnDllChange(HWND hWnd, LONG DllType, LONG CameraType)
{
	// ckk؂ւۂ͈USĊJ܂B
	// ̃J̓\sۂ CArtCamSdk 𕡐`Kv܂B
	// `Ăꍇ̓J؂ւ̍ۂɊJKv͂ȂȂ܂B
	g_CArtCamSdk.Release();
	g_CArtCamSdk.FreeLibrary();


	if(!g_CArtCamSdk.LoadLibrary(const_cast<LPTSTR>(DLLNAMELIST[DllType]))){
		TCHAR Error[256]="";
		wsprintf(Error, "%s܂\nNDLLړ\܂", DLLNAMELIST[DllType]);
		MessageBox(hWnd, Error, "G[", MB_OK);
		return FALSE;
	}

	// Initialize ͍ŏɌĂт܂
	// ŃEBhEnhݒ肷WM_ERROR擾鎖o
	if(!g_CArtCamSdk.Initialize(hWnd)){
		MessageBox(hWnd, "rcj̏Ɏs܂", "G[", MB_OK);
		return FALSE;
	}


	// 
	if(-1 != CameraType && ARTCAM_CAMERATYPE_SATA == HIWORD(g_CArtCamSdk.GetDllVersion())){
		g_CArtCamSdk.SetCameraType(CameraType);
		g_CArtCamSdk.SetDeviceNumber(0);
	}


	// j[`FbN
	for(int i=0; i<DLLCOUNT; i++){
		::CheckMenuItem(g_Menu.Dll, i, MF_BYPOSITION | MF_UNCHECKED);
	}

	::CheckMenuItem(g_Menu.Dll, DllType, MF_BYPOSITION | MF_CHECKED);


	// ݒEBhE̎gp\Ԃ̐؂ւ
	switch(DllType){
	// CNV
	case 0:
	case 3:
		::EnableMenuItem(g_Menu.Set, 0, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Set, 1, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Set, 2, MF_BYPOSITION | MF_GRAYED);

		::EnableMenuItem(g_Menu.Rate, 0, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Rate, 1, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Rate, 2, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Rate, 3, MF_BYPOSITION | MF_ENABLED);
	break;

	// ̑
	default:
		::EnableMenuItem(g_Menu.Set, 0, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Set, 1, MF_BYPOSITION | MF_ENABLED);
		::EnableMenuItem(g_Menu.Set, 2, MF_BYPOSITION | MF_ENABLED);

		::EnableMenuItem(g_Menu.Rate, 0, MF_BYPOSITION | MF_GRAYED);
		::EnableMenuItem(g_Menu.Rate, 1, MF_BYPOSITION | MF_GRAYED);
		::EnableMenuItem(g_Menu.Rate, 2, MF_BYPOSITION | MF_GRAYED);
		::EnableMenuItem(g_Menu.Rate, 3, MF_BYPOSITION | MF_GRAYED);
	break;
	}


	// foCXύXj[
	for(i=0; i<g_DeviceCount; i++){
		::DeleteMenu(g_Menu.Device, 0, MF_BYPOSITION | MF_STRING);
	}


	TCHAR szName[10][256];
	g_DeviceCount = g_CArtCamSdk.EnumDevice(szName);
	for(i=0; i<g_DeviceCount; i++){
		::InsertMenu(g_Menu.Device, i, MF_BYPOSITION | MF_STRING, IDM_DEVICE + i, szName[i]);
	}
	::CheckMenuItem(g_Menu.Device, 0, MF_BYPOSITION | MF_CHECKED);


	switch(g_Preview){
	case 0:	return OnPreview(hWnd);
	case 1:	return OnCallBack(hWnd);
	case 3:	return OnCapture(hWnd);
	case 4:	return OnTrigger(hWnd);
	}

	return FALSE;
}



//////////////////////////////////////////////////////////////////////////////////////////////
//
//	foCX؂ւ
//

BOOL OnDeviceChange(HWND hWnd, LONG Number)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}


	// foCXύXOɎgp̃foCXJ
	g_CArtCamSdk.Close();

	// ŃfoCX̔ԍύXĂJ\ƃfoCXύX
	// F̊֐P̂ł̓foCX͕ύX܂B
	// @@̊֐ĂяoɃfoCX鎖ŃfoCXύX܂
	g_CArtCamSdk.SetDeviceNumber(Number);

	for(int i=0; i<g_DeviceCount; i++){
		::CheckMenuItem(g_Menu.Device, i, MF_BYPOSITION | MF_UNCHECKED);
	}

	::CheckMenuItem(g_Menu.Device, Number, MF_BYPOSITION | MF_CHECKED);

	switch(g_Preview){
	case 0:	return OnPreview(hWnd);
	case 1:	return OnCallBack(hWnd);
	case 3:	return OnCapture(hWnd);
	case 4:	return OnTrigger(hWnd);
	}

	return FALSE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	TvO[g؂ւ
//

BOOL OnRateChange(HWND hWnd, LONG Number)
{
	// DLLI
	if(-1 == g_DllType){
		MessageBox(hWnd, "ڑĂJDLLIĂ", "G[", MB_OK);
		return FALSE;
	}


	// foCXύXOɎgp̃foCXJ
	g_CArtCamSdk.Close();

	g_CArtCamSdk.SetSamplingRate(Number);

	for(int i=0; i<4; i++){
		::CheckMenuItem(g_Menu.Rate, i, MF_BYPOSITION | MF_UNCHECKED);
	}

	::CheckMenuItem(g_Menu.Rate, Number, MF_BYPOSITION | MF_CHECKED);

	switch(g_Preview){
	case 0:	return OnPreview(hWnd);
	case 1:	return OnCallBack(hWnd);
	case 3:	return OnCapture(hWnd);
	case 4:	return OnTrigger(hWnd);
	}

	return FALSE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_CREATE
//

LRESULT OnCreate(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	TCHAR szFilePath[MAX_PATH]="";
	TCHAR szExePath[3][MAX_PATH]={"","",""};
	GetModuleFileName(::GetModuleHandle(NULL), szExePath[0], MAX_PATH);
	_splitpath(szExePath[0], szExePath[1], szExePath[2], NULL, NULL);
	wsprintf(szFilePath, "%s%sSample.ini", szExePath[1], szExePath[2]);

	g_DllType = ::GetPrivateProfileInt("Sample", "DllType", -1, szFilePath);
	g_CameraType = ::GetPrivateProfileInt("Sample", "CameraType", -1, szFilePath);

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_COMMAND
//

LRESULT OnCommand(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	switch (LOWORD(wParam)){
	// t@Cۑ
	case IDM_SAVE:
//		g_CArtCamSdk.SaveImage("Image.bmp", FILETYPE_BITMAP);
//		g_CArtCamSdk.SaveImage("Image.raw", FILETYPE_RAW);
		g_CArtCamSdk.SaveImage("Imageh.jpg", FILETYPE_JPEG_HIGH);
//		g_CArtCamSdk.SaveImage("Imagen.jpg", FILETYPE_JPEG_NOMAL);
//		g_CArtCamSdk.SaveImage("Imagel.jpg", FILETYPE_JPEG_LOW);
//		g_CArtCamSdk.SaveImage("Image.png", FILETYPE_PNG);
//		g_CArtCamSdk.SaveImage("Image.tif", FILETYPE_TIFF);
	return 1;

	// I
	case IDM_EXIT:
		::PostMessage(hWnd, WM_CLOSE, 0, 0);
	return 1;

	// rcjŕ`悷
	case IDM_PREVIEW:
		OnPreview(hWnd);
	return 1;

	// f̃|C^擾ĎOŕ`悷
	case IDM_CALLBACK:
		OnCallBack(hWnd);
	return 1;

	// fP擾
	case IDM_SNAPSHOT:
		OnSnapShot(hWnd);
	return 1;

	// AŃXibvVbgB
	case IDM_CAPTURE:
		OnCapture(hWnd);
	return 1;

	// gK[[h
	case IDM_TRIGGER:
		OnTrigger(hWnd);
	return 1;

	// Jݒ
	case IDM_FORMAT:
		// Jݒ_CAO\ۂ͕\͈U鎖𐄏܂
		// \AvP[VŒ~ȂƂrcjŉfXV͒~܂B
		// rcjŒ~ꍇ̓_CAO_ōĊJ܂A
		// ̍ېݒύXāA_CAOꍇ̓AvP[V̐ݒ𔽉fȂ
		// šɂȂ\܂B
		if(3 == g_Preview)	KillTimer(hWnd, TIMER_ID);

		g_CArtCamSdk.Close();
		g_CArtCamSdk.SetCameraDlg(hWnd);

		switch(g_Preview){
		case 0:	return OnPreview(hWnd);
		case 1:	return OnCallBack(hWnd);
		case 3:	return OnCapture(hWnd);
		case 4:	return OnTrigger(hWnd);
		}
	return 1;

	// tB^[ݒ
	case IDM_FILTER:
		g_CArtCamSdk.SetImageDlg(hWnd);
	return 1;

	// AiOݒ
	case IDM_ANALOG:
		g_CArtCamSdk.SetAnalogDlg(hWnd);
	return 1;

	// DLL؂ւ
	case IDM_CAM:		g_DllType =  0;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_USTC:		g_DllType =  2;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_CNV:		g_DllType =  3;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_130MI:		g_DllType =  5;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_200MI:		g_DllType =  6;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_300MI:		g_DllType =  7;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_150P:		g_DllType =  8;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_320P:		g_DllType =  9;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_200SH:		g_DllType = 10;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_098:		g_DllType = 11;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_036MI:		g_DllType = 12;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_500P:		g_DllType = 13;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_150P2:		g_DllType = 14;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_500MI:		g_DllType = 15;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_T111:		g_DllType = 16;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_T112:		g_DllType = 17;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_150P3:		g_DllType = 18;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_130MIV:	g_DllType = 19;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_150P3V:	g_DllType = 20;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_267KY:		g_DllType = 21;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_274KY:		g_DllType = 22;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_625KY:		g_DllType = 23;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_V135MI:	g_DllType = 24;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
    case IDM_445KY:		g_DllType = 28;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
    case IDM_098II:		g_DllType = 29;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
    case IDM_MV413:		g_DllType = 30;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
    case IDM_OV210:		g_DllType = 31;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
    case IDM_850SH:		g_DllType = 32;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
    case IDM_1251SH:	g_DllType = 33;	g_CameraType = -1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_D131:      g_DllType = 34; g_CameraType = -1;  OnDllChange(hWnd, g_DllType, g_CameraType); return 1;
	case IDM_900MI:     g_DllType = 35; g_CameraType = -1;  OnDllChange(hWnd, g_DllType, g_CameraType); return 1;
	case IDM_1000MI:    g_DllType = 36; g_CameraType = -1;  OnDllChange(hWnd, g_DllType, g_CameraType); return 1;
	case IDM_500P2:		g_DllType = 37; g_CameraType = -1;  OnDllChange(hWnd, g_DllType, g_CameraType); return 1;

	case IDM_SATA_LVDS:		g_DllType = 26;	g_CameraType = 0;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_300MI:	g_DllType = 26;	g_CameraType = 1;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_500MI:	g_DllType = 26;	g_CameraType = 2;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_MV413:	g_DllType = 26;	g_CameraType = 3;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_800MI:	g_DllType = 26;	g_CameraType = 4;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_036MI:	g_DllType = 26;	g_CameraType = 5;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_150P3:	g_DllType = 26;	g_CameraType = 6;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_267KY:	g_DllType = 26;	g_CameraType = 6;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_274KY:	g_DllType = 26;	g_CameraType = 7;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_625KY:	g_DllType = 26;	g_CameraType = 8;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_130MI:	g_DllType = 26;	g_CameraType = 9;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;
	case IDM_SATA_200MI:	g_DllType = 26;	g_CameraType =10;	OnDllChange(hWnd, g_DllType, g_CameraType);	return 1;


	// 
	case IDM_WIDEHI:		OnRateChange(hWnd, 0);	return 1;
	case IDM_WIDELOW:		OnRateChange(hWnd, 1);	return 1;
	case IDM_NORMALHI:		OnRateChange(hWnd, 2);	return 1;
	case IDM_NORMALLOW:		OnRateChange(hWnd, 3);	return 1;
	}


	// foCXύX
	for(int i=0; i<g_DeviceCount; i++){
		if(IDM_DEVICE + i == LOWORD(wParam)){
			OnDeviceChange(hWnd, i);
			return 1;
		}
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_PAINT
//

LRESULT OnPaint(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT psPaint;
	HDC hDC = BeginPaint(hWnd, &psPaint);
	if(hDC){
		DrawImage(hWnd, hDC);
		EndPaint(hWnd, &psPaint);
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_ERROR
//

LRESULT OnError(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if(0 <= lParam && lParam < ERRORCOUNT-1){
		SetWindowText(hWnd, ERRORLIST[lParam]);
	}
	else {
		// s̃G[
		SetWindowText(hWnd, ERRORLIST[ARTCAMSDK_UNKNOWN]);
	}

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_GRAPHPAINT
//

LRESULT OnGraphPaint(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if(NULL == wParam){
		return OnError(hWnd, wParam, lParam);
	}


	// ̃bZ[W_ g_pImage ɂ͍ŐV̉fi[Ă
	LPGP_INFO pGpInfo = (LPGP_INFO)wParam;
	DrawImage(hWnd, NULL);


	TCHAR Fps[256]="";
	sprintf(Fps, "Tv  %.1f t[", double(pGpInfo->lFps) / 10.0);
	SetWindowText(hWnd, Fps);

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_DESTROY
//

LRESULT OnDestroy(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	// Release ̓J̎gpIƂɌĂяo܂ifXgN^łĂ΂܂j
	// Release ɍēxJgpꍇ Initialize ĂԕKv܂
	g_CArtCamSdk.Release();
	g_CDibCapture.Release();
	g_CDibView.Release();


	TCHAR szFilePath[MAX_PATH]="";
	TCHAR szExePath[3][MAX_PATH]={"","",""};
	GetModuleFileName(::GetModuleHandle(NULL), szExePath[0], MAX_PATH);
	_splitpath(szExePath[0], szExePath[1], szExePath[2], NULL, NULL);
	wsprintf(szFilePath, "%s%sSample.ini", szExePath[1], szExePath[2]);


	TCHAR Data[32]="";
	wsprintf(Data, "%d", g_DllType);
	::WritePrivateProfileString("Sample", "DllType", Data, szFilePath);

	wsprintf(Data, "%d", g_CameraType);
	::WritePrivateProfileString("Sample", "CameraType", Data, szFilePath);


	::PostQuitMessage(0);
	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_SIZE
//

LRESULT OnSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if(0 == g_Preview){
		HWND hChild = GetWindow(hWnd, GW_CHILD);

		RECT rc;
		GetClientRect(hWnd, &rc);


		// AXyNgςȂꍇ͂̃̕RgOĂ
/*
		// vZ͏PʂɂȂ̂ňU_^ɂĂ܂
		double winW = rc.right;
		double winH = rc.bottom;
		double capW = ArtCamGetWidth();
		double capH = ArtCamGetHeight();

		if( (winW * capH) > (winH * capW) ){
			winW = winH * capW / capH;
			rc.right = LONG(winW);
		}
		else if( (winW * capH) < (winH * capW) ){
			winH = winW * capH / capW;
			rc.bottom = LONG(winH);
		}
*/
		SetWindowPos(hChild, HWND_TOP, 0, 0, rc.right, rc.bottom, SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW);
	}

	if(1 == g_Preview || 3 == g_Preview || 4 == g_Preview){
		ChangeScrollbar(hWnd);
	}

	return 1;
}


/////////////////////////////////////////////////////////////////////////////
//
//	WM_HSCROLL
//

LRESULT OnHScroll(HWND hWnd, UINT nSBCode, UINT nPos, HWND ScrollBar)
{
	SCROLLINFO sc;
	GetScrollInfo(hWnd, SB_HORZ, &sc);

	switch(nSBCode){
	// [փXN[B
	case SB_LEFT:
		SetScrollPos(hWnd, SB_HORZ, 0, TRUE);
	break;

	// XN[IB
	case SB_ENDSCROLL:
	break;

	// փXN[B
	case SB_LINELEFT:
		SetScrollPos(hWnd, SB_HORZ, GetScrollPos(hWnd, SB_HORZ) - sc.nPage/4, TRUE);
	break;

	// EփXN[B
	case SB_LINERIGHT:
		SetScrollPos(hWnd, SB_HORZ, GetScrollPos(hWnd, SB_HORZ) + sc.nPage/4, TRUE);
	break;

	// 1 y[WփXN[B
	case SB_PAGELEFT:
		SetScrollPos(hWnd, SB_HORZ, GetScrollPos(hWnd, SB_HORZ) - sc.nPage, TRUE);
	break;

	// 1 y[WEփXN[B
	case SB_PAGERIGHT:
		SetScrollPos(hWnd, SB_HORZ, GetScrollPos(hWnd, SB_HORZ) + sc.nPage, TRUE);
	break;

	// E[փXN[B
	case SB_RIGHT:
		SetScrollPos(hWnd, SB_HORZ, sc.nMax, TRUE);
	break;

	// ΈʒuփXN[B݈ʒu͈ nPos Ŏw肳܂B
	case SB_THUMBPOSITION:
		nPos &= 0x0000FFFF;
		SetScrollPos(hWnd, SB_HORZ, nPos, TRUE);
	break;

	// XN[ {bNXwʒuփhbO܂B݈ʒu͈ nPos Ŏw肳܂B 
	case SB_THUMBTRACK:
		nPos &= 0x0000FFFF;
		SetScrollPos(hWnd, SB_HORZ, nPos, TRUE);
	break;
	}

	g_ScrollCtrl.Pos.x = GetScrollPos(hWnd, SB_HORZ);
	DrawImage(hWnd, NULL);

	return 1;
}


/////////////////////////////////////////////////////////////////////////////
//
//	WM_VSCROLL
//

LRESULT OnVScroll(HWND hWnd, UINT nSBCode, UINT nPos, HWND ScrollBar)
{
	SCROLLINFO sc;
	GetScrollInfo(hWnd, SB_VERT, &sc);
	LONG pos = GetScrollPos(hWnd, SB_VERT);


	switch(nSBCode){
	// [փXN[B
	case SB_LEFT:
		SetScrollPos(hWnd, SB_VERT, 0, TRUE);
	break;

	// XN[IB
	case SB_ENDSCROLL:
	break;

	// փXN[B
	case SB_LINELEFT:
		SetScrollPos(hWnd, SB_VERT, GetScrollPos(hWnd, SB_VERT) - sc.nPage/4, TRUE);
	break;

	// EփXN[B
	case SB_LINERIGHT:
		SetScrollPos(hWnd, SB_VERT, GetScrollPos(hWnd, SB_VERT) + sc.nPage/4, TRUE);
	break;

	// 1 y[WփXN[B
	case SB_PAGELEFT:
		SetScrollPos(hWnd, SB_VERT, GetScrollPos(hWnd, SB_VERT) - sc.nPage, TRUE);
	break;

	// 1 y[WEփXN[B
	case SB_PAGERIGHT:
		SetScrollPos(hWnd, SB_VERT, GetScrollPos(hWnd, SB_VERT) + sc.nPage, TRUE);
	break;

	// E[փXN[B
	case SB_RIGHT:
		SetScrollPos(hWnd, SB_VERT, sc.nMax, TRUE);
	break;

	// ΈʒuփXN[B݈ʒu͈ nPos Ŏw肳܂B
	case SB_THUMBPOSITION:
		nPos &= 0x0000FFFF;
		SetScrollPos(hWnd, SB_VERT, nPos, TRUE);
	break;

	// XN[ {bNXwʒuփhbO܂B݈ʒu͈ nPos Ŏw肳܂B 
	case SB_THUMBTRACK:
		nPos &= 0x0000FFFF;
		SetScrollPos(hWnd, SB_VERT, nPos, TRUE);
	break;
	}

	
	g_ScrollCtrl.Pos.y = GetScrollPos(hWnd, SB_VERT);
	DrawImage(hWnd, NULL);

	return 1;
}


/////////////////////////////////////////////////////////////////////////////
//
//	WM_MOUSEMOVE
//

LRESULT OnMouseMove(HWND hWnd, LONG xPos, LONG yPos)
{
	DrawImage(hWnd, NULL);

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	EBhEvV[W
//

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_CREATE:		return OnCreate			(hWnd, wParam, lParam);
	case WM_COMMAND:	return OnCommand		(hWnd, wParam, lParam);
	case WM_PAINT:		return OnPaint			(hWnd, wParam, lParam);
	case WM_GRAPHPAINT:	return OnGraphPaint		(hWnd, wParam, lParam);
	case WM_ERROR:		return OnError			(hWnd, wParam, lParam);
	case WM_DESTROY:	return OnDestroy		(hWnd, wParam, lParam);
	case WM_SIZE:		return OnSize			(hWnd, wParam, lParam);
	case WM_TIMER:		return OnTimer			(hWnd, wParam, lParam);
	case WM_HSCROLL:	return OnHScroll		(hWnd, LOWORD(wParam), HIWORD(wParam), (HWND)lParam);
	case WM_VSCROLL:	return OnVScroll		(hWnd, LOWORD(wParam), HIWORD(wParam), (HWND)lParam);
	case WM_MOUSEMOVE:	return OnMouseMove		(hWnd, LOWORD(lParam), HIWORD(lParam));
	default:			return ::DefWindowProc	(hWnd, uMsg, wParam, lParam);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	EBhE
//

HWND InitWindow(HINSTANCE hInstance, int nCmdShow)
{
	// EBhENXo^
	WNDCLASSEX wndclassex;
	ZeroMemory(&wndclassex,		sizeof(wndclassex));
	wndclassex.cbSize			= sizeof(wndclassex);
	wndclassex.style			= 0;
	wndclassex.lpfnWndProc		= WndProc;
	wndclassex.cbClsExtra		= 0;
	wndclassex.cbWndExtra		= 0;
	wndclassex.hInstance		= hInstance;
	wndclassex.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wndclassex.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wndclassex.hbrBackground	= reinterpret_cast<HBRUSH>(::GetStockObject(BLACK_BRUSH));
	wndclassex.lpszClassName	= "Tv";
	wndclassex.lpszMenuName		= 0;
	wndclassex.hIconSm			= NULL;

	if(0 == ::RegisterClassEx(&wndclassex))
		return NULL;

	// EBhETCYݒ
	RECT rcWndSize = {0, 0, 900, 600};
	DWORD dwStyle = WS_POPUPWINDOW | WS_CAPTION | WS_OVERLAPPEDWINDOW | WS_VSCROLL | WS_HSCROLL;
	if(0 == ::AdjustWindowRectEx(&rcWndSize, dwStyle, TRUE, NULL))
		return NULL;

	// CEBhE
	HWND hWnd = ::CreateWindowEx(NULL, "Tv", "Tv", dwStyle,
			(::GetSystemMetrics(SM_CXSCREEN) - (rcWndSize.right - rcWndSize.left)) / 2,
			(::GetSystemMetrics(SM_CYSCREEN) - (rcWndSize.bottom - rcWndSize.top)) / 2,
			rcWndSize.right - rcWndSize.left, rcWndSize.bottom - rcWndSize.top,
			HWND_DESKTOP, NULL, hInstance, NULL);

	if(NULL == hWnd)
		return NULL;


	// j[쐬

	// t@Cj[
	g_Menu.File = ::CreateMenu();
	::InsertMenu(g_Menu.File, 0, MF_BYPOSITION | MF_STRING, IDM_SAVE, "ۑ(&S)");
	::InsertMenu(g_Menu.File, 1, MF_BYPOSITION | MF_STRING, IDM_EXIT, "I(&X)");

	// \j[
	g_Menu.Preview = ::CreateMenu();
	::InsertMenu(g_Menu.Preview, 0, MF_BYPOSITION | MF_STRING, IDM_PREVIEW, "vr[(&P)");
	::InsertMenu(g_Menu.Preview, 1, MF_BYPOSITION | MF_STRING, IDM_CALLBACK, "R[obN(&B)");
	::InsertMenu(g_Menu.Preview, 2, MF_BYPOSITION | MF_STRING, IDM_SNAPSHOT, "XibvVbg(&S)");
	::InsertMenu(g_Menu.Preview, 3, MF_BYPOSITION | MF_STRING, IDM_CAPTURE, "Lv`(&C)");
	::InsertMenu(g_Menu.Preview, 4, MF_BYPOSITION | MF_STRING, IDM_TRIGGER, "gK[(&T)");

	// ݒ胁j[
	g_Menu.Set = ::CreateMenu();
	::InsertMenu(g_Menu.Set, 0, MF_BYPOSITION | MF_STRING, IDM_FORMAT, "tH[}bgݒ(&C)");
	::InsertMenu(g_Menu.Set, 1, MF_BYPOSITION | MF_STRING, IDM_FILTER, "tB^[ݒ(&F)");
	::InsertMenu(g_Menu.Set, 2, MF_BYPOSITION | MF_STRING, IDM_ANALOG, "AiOݒ(&A)");

	// DLLIj[
	g_Menu.Dll = ::CreateMenu();
	::InsertMenu(g_Menu.Dll,  0, MF_BYPOSITION | MF_STRING, IDM_CAM,		"DirectShow Camera");
	::InsertMenu(g_Menu.Dll,  1, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL );
	::InsertMenu(g_Menu.Dll,  2, MF_BYPOSITION | MF_STRING, IDM_USTC,		"ARTUST");
	::InsertMenu(g_Menu.Dll,  3, MF_BYPOSITION | MF_STRING, IDM_CNV,		"ARTCNV");
	::InsertMenu(g_Menu.Dll,  4, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL );
	::InsertMenu(g_Menu.Dll,  5, MF_BYPOSITION | MF_STRING, IDM_130MI,		"ARTCAM-130MI");
	::InsertMenu(g_Menu.Dll,  6, MF_BYPOSITION | MF_STRING, IDM_200MI,		"ARTCAM-200MI");
	::InsertMenu(g_Menu.Dll,  7, MF_BYPOSITION | MF_STRING, IDM_300MI,		"ARTCAM-300MI");
	::InsertMenu(g_Menu.Dll,  8, MF_BYPOSITION | MF_STRING, IDM_150P,		"ARTCAM-150P");
	::InsertMenu(g_Menu.Dll,  9, MF_BYPOSITION | MF_STRING, IDM_320P,		"ARTCAM-320P");
	::InsertMenu(g_Menu.Dll, 10, MF_BYPOSITION | MF_STRING, IDM_200SH,		"ARTCAM-200SH");
	::InsertMenu(g_Menu.Dll, 11, MF_BYPOSITION | MF_STRING, IDM_098,		"ARTCAM-098");
	::InsertMenu(g_Menu.Dll, 12, MF_BYPOSITION | MF_STRING, IDM_036MI,		"ARTCAM-036MI");
	::InsertMenu(g_Menu.Dll, 13, MF_BYPOSITION | MF_STRING, IDM_500P,		"ARTCAM-500P");
	::InsertMenu(g_Menu.Dll, 14, MF_BYPOSITION | MF_STRING, IDM_150P2,		"ARTCAM-150P2");
	::InsertMenu(g_Menu.Dll, 15, MF_BYPOSITION | MF_STRING, IDM_500MI,		"ARTCAM-500MI");
	::InsertMenu(g_Menu.Dll, 16, MF_BYPOSITION | MF_STRING, IDM_T111,		"ARTCAM-T111");
	::InsertMenu(g_Menu.Dll, 17, MF_BYPOSITION | MF_STRING, IDM_T112,		"ARTCAM-T112");
	::InsertMenu(g_Menu.Dll, 18, MF_BYPOSITION | MF_STRING, IDM_150P3,		"ARTCAM-150P3");
	::InsertMenu(g_Menu.Dll, 19, MF_BYPOSITION | MF_STRING, IDM_130MIV,		"ARTCAM-130MI MOUT");
	::InsertMenu(g_Menu.Dll, 20, MF_BYPOSITION | MF_STRING, IDM_150P3V,		"ARTCAM-150P3 MOUT");
	::InsertMenu(g_Menu.Dll, 21, MF_BYPOSITION | MF_STRING, IDM_267KY,		"ARTCAM-267KY");
	::InsertMenu(g_Menu.Dll, 22, MF_BYPOSITION | MF_STRING, IDM_274KY,		"ARTCAM-274KY");
	::InsertMenu(g_Menu.Dll, 23, MF_BYPOSITION | MF_STRING, IDM_625KY,		"ARTCAM-625KY");
	::InsertMenu(g_Menu.Dll, 24, MF_BYPOSITION | MF_STRING, IDM_V135MI,		"ARTCAM-V135MI");
    ::InsertMenu(g_Menu.Dll, 25, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL );
	::InsertMenu(g_Menu.Dll, 27, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL );
    ::InsertMenu(g_Menu.Dll, 28, MF_BYPOSITION | MF_STRING, IDM_445KY,		"ARTCAM-445KY");
	::InsertMenu(g_Menu.Dll, 29, MF_BYPOSITION | MF_STRING, IDM_098II,		"ARTCAM-098II");
	::InsertMenu(g_Menu.Dll, 30, MF_BYPOSITION | MF_STRING, IDM_MV413,		"ARTCAM-MV413");
	::InsertMenu(g_Menu.Dll, 31, MF_BYPOSITION | MF_STRING, IDM_OV210,  "ARTCAM-OV210");
	::InsertMenu(g_Menu.Dll, 32, MF_BYPOSITION | MF_STRING, IDM_850SH,  "ARTCAM-850SH");
	::InsertMenu(g_Menu.Dll, 33, MF_BYPOSITION | MF_STRING, IDM_1251SH,  "ARTCAM-1251SH");
	::InsertMenu(g_Menu.Dll, 34, MF_BYPOSITION | MF_STRING, IDM_D131,  "ARTCAM-D131");
	::InsertMenu(g_Menu.Dll, 35, MF_BYPOSITION | MF_STRING, IDM_900MI,		"ARTCAM-900MI");
	::InsertMenu(g_Menu.Dll, 36, MF_BYPOSITION | MF_STRING, IDM_1000MI,		"ARTCAM-1000MI");
	::InsertMenu(g_Menu.Dll, 37, MF_BYPOSITION | MF_STRING, IDM_500P2,		"ARTCAM-500P2");


	// SATA J
	HMENU MenuSata = ::CreateMenu();
	::InsertMenu(MenuSata, 0, MF_BYPOSITION | MF_STRING, IDM_SATA_LVDS,   "LVDS");
	::InsertMenu(MenuSata, 1, MF_BYPOSITION | MF_STRING, IDM_SATA_300MI,  "300MI");
	::InsertMenu(MenuSata, 2, MF_BYPOSITION | MF_STRING, IDM_SATA_500MI,  "500MI");
	::InsertMenu(MenuSata, 3, MF_BYPOSITION | MF_STRING, IDM_SATA_MV413,  "MV413");
	::InsertMenu(MenuSata, 4, MF_BYPOSITION | MF_STRING, IDM_SATA_800MI,  "800MI");
	::InsertMenu(MenuSata, 5, MF_BYPOSITION | MF_STRING, IDM_SATA_036MI,  "036MI");
	::InsertMenu(MenuSata, 6, MF_BYPOSITION | MF_STRING, IDM_SATA_150P3,  "150P3");
	::InsertMenu(MenuSata, 7, MF_BYPOSITION | MF_STRING, IDM_SATA_267KY,  "267KY");
	::InsertMenu(MenuSata, 8, MF_BYPOSITION | MF_STRING, IDM_SATA_274KY,  "274KY");
	::InsertMenu(MenuSata, 9, MF_BYPOSITION | MF_STRING, IDM_SATA_625KY,  "625KY");
	::InsertMenu(MenuSata,10, MF_BYPOSITION | MF_STRING, IDM_SATA_130MI,  "130MI");
	::InsertMenu(MenuSata,11, MF_BYPOSITION | MF_STRING, IDM_SATA_200MI,  "200MI");
	::InsertMenu(g_Menu.Dll, 26, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT_PTR)MenuSata,  "SATA");


	// TvO[gj[
	g_Menu.Rate = ::CreateMenu();
	::InsertMenu(g_Menu.Rate,  0, MF_BYPOSITION | MF_STRING, IDM_WIDEHI, "Wide HiSpeed");
	::InsertMenu(g_Menu.Rate,  1, MF_BYPOSITION | MF_STRING, IDM_WIDELOW, "Wide LowSpeed");
	::InsertMenu(g_Menu.Rate,  2, MF_BYPOSITION | MF_STRING, IDM_NORMALHI, "Normal HiSpeed");
	::InsertMenu(g_Menu.Rate,  3, MF_BYPOSITION | MF_STRING, IDM_NORMALLOW, "Normal LowSpeed");

	// DLL邩`FbN
	for(int i=0; i<DLLCOUNT; i++){
		CArtCamSdk ArtCam;
		if(!ArtCam.LoadLibrary(const_cast<LPTSTR>(DLLNAMELIST[i]))){
			::EnableMenuItem(g_Menu.Dll, i, MF_BYPOSITION | MF_GRAYED);
		}
	}



	// foCXύXj[
	g_Menu.Device = ::CreateMenu();

	// Cj[
	HMENU hMenu = ::CreateMenu();
	::InsertMenu(hMenu, 0, MF_POPUP | MF_STRING, (UINT)g_Menu.File,    "t@C(&F)");
	::InsertMenu(hMenu, 1, MF_POPUP | MF_STRING, (UINT)g_Menu.Preview, "\(&V)");
	::InsertMenu(hMenu, 2, MF_POPUP | MF_STRING, (UINT)g_Menu.Set,     "ݒ(&S)");
	::InsertMenu(hMenu, 3, MF_POPUP | MF_STRING, (UINT)g_Menu.Dll,     "ckk(&L)");
	::InsertMenu(hMenu, 4, MF_POPUP | MF_STRING, (UINT)g_Menu.Device,  "foCX(&D)");
	::InsertMenu(hMenu, 5, MF_POPUP | MF_STRING, (UINT)g_Menu.Rate,    "[g(&D)");


	::SetMenu(hWnd, hMenu);


	// tH[JX̐ݒ
	::SetFocus(hWnd);
	::ShowWindow(hWnd, nCmdShow);
	if(0 == ::UpdateWindow(hWnd))
		return NULL;

	// J̏
	if(-1 != g_DllType)
		OnDllChange(hWnd, g_DllType, g_CameraType);

	SetTimer(hWnd, 1, 100, NULL);
	return hWnd;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WinMain
//

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmLine, int nCmdShow)
{
	HWND hWnd = InitWindow(hInstance, nCmdShow);

	// bZ[W[v
	MSG msg;
	ZeroMemory(&msg, sizeof(msg));
	while(::GetMessage(&msg, NULL, 0, 0)){
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}

	return msg.wParam;
}



