unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Menus, ArtCam, AppEvnts, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    PopupFile: TMenuItem;
    PopupShow: TMenuItem;
    PopupSet: TMenuItem;
    PopupDevice: TMenuItem;
    PopupDll: TMenuItem;
    FileSave: TMenuItem;
    FileExit: TMenuItem;
    ShowPreview: TMenuItem;
    ShowCallBack: TMenuItem;
    ShowSnapShot: TMenuItem;
    ShowCapture: TMenuItem;
    ShowTrigger: TMenuItem;
    SetCamera: TMenuItem;
    SetFilter: TMenuItem;
    SetAnalog: TMenuItem;
    Device0: TMenuItem;
    Device1: TMenuItem;
    Device2: TMenuItem;
    Device3: TMenuItem;
    Device4: TMenuItem;
    Device5: TMenuItem;
    Device6: TMenuItem;
    Device7: TMenuItem;
    Device8: TMenuItem;
    Device9: TMenuItem;
    DIRECTSHOW: TMenuItem;
    ARTUST: TMenuItem;
    ARTCNV: TMenuItem;
    ARTCAM130MI: TMenuItem;
    ARTCAM200MI: TMenuItem;
    ARTCAM300MI: TMenuItem;
    ARTCAM150P: TMenuItem;
    ARTCAM320P: TMenuItem;
    ARTCAM200SH: TMenuItem;
    ARTCAM098: TMenuItem;
    ARTCAM036MI: TMenuItem;
    ARTCAM500P: TMenuItem;
    ARTCAM150P2: TMenuItem;
    Timer1: TTimer;
    N1: TMenuItem;
    N2: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure PreviewClick(Sender: TObject);
    procedure CallBackClick(Sender: TObject);
    procedure SnapShotClick(Sender: TObject);
    procedure CaptureClick(Sender: TObject);
    procedure TriggerClick(Sender: TObject);
    procedure SetCameraClick(Sender: TObject);
    procedure SetFilterClick(Sender: TObject);
    procedure SetAnalogClick(Sender: TObject);
    procedure Device0Click(Sender: TObject);
    procedure Device1Click(Sender: TObject);
    procedure Device2Click(Sender: TObject);
    procedure Device3Click(Sender: TObject);
    procedure Device4Click(Sender: TObject);
    procedure Device5Click(Sender: TObject);
    procedure Device6Click(Sender: TObject);
    procedure Device7Click(Sender: TObject);
    procedure Device8Click(Sender: TObject);
    procedure Device9Click(Sender: TObject);
    procedure DSCameraClick(Sender: TObject);
    procedure ARTUSTClick(Sender: TObject);
    procedure ARTCNVClick(Sender: TObject);
    procedure ARTCAM130MIClick(Sender: TObject);
    procedure ARTCAM200MIClick(Sender: TObject);
    procedure ARTCAM300MIClick(Sender: TObject);
    procedure ARTCAM150PClick(Sender: TObject);
    procedure ARTCAM320PClick(Sender: TObject);
    procedure ARTCAM200SHClick(Sender: TObject);
    procedure ARTCAM098Click(Sender: TObject);
    procedure ARTCAM036MIClick(Sender: TObject);
    procedure ARTCAM500PClick(Sender: TObject);
    procedure ARTCAM150P2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private 錾 }
  public
    procedure CreateBitmap;
    procedure DrawImage;
    procedure DeviceChange(Sender: TObject; Number: Integer);
    procedure DllChange(Sender: TObject; Number: Integer);
    function ArtCamGetWidth: Integer;
    function ArtCamGetHeight: Integer;
    function ArtCamGetColor: Integer;
    function ArtCamGetBpp: Integer;
    function ArtCamGetSize: Integer;
  end;

  function MsgProc(code: integer; wparam: WPARAM; lparam: LPARAM): LRESULT; stdcall;

var
  Form1: TForm1;
  BmpDraw: TBitmap;
  ArtCam1: TArtCam;
  Hook: HHOOK;
  PreviewMode: Integer;

const
  SUB_SAMPLE: array[0..3] of Integer = (1, 2, 4, 8);


implementation

{$R *.dfm}


//////////////////////////////////////////////////
// Lv`bZ[W󂯎
//////////////////////////////////////////////////
function MsgProc(code: integer; wparam: WPARAM; lparam: LPARAM): LRESULT; stdcall;
var
  Msg: PMsg;
begin
  if code < 0 then begin
    result := CallNextHookEx(Hook, code, wparam, lparam);
    exit;
  end;

  if code = HC_ACTION then begin
    Msg := PMsg(lparam);

    case Msg.message of
      // `R[h@ŐV̉f荞܂ꂽۂɂrcj瑗܂
      UINT(WM_GRAPHPAINT): begin
        Form1.DrawImage;
      end;

      // G[R[h
      UINT(WM_ERROR): begin
        case ARTCAMSDK_ERROR(Msg.lParam) of
          ARTCAMSDK_NOERROR:        Form1.Caption := 'Sample';
          ARTCAMSDK_NOT_INITIALIZE: Form1.Caption := 'Sample Ă܂';
          ARTCAMSDK_DISABLEDDEVICE: Form1.Caption := 'Sample ps\ȃfoCXɃANZX悤Ƃ܂';
          ARTCAMSDK_CREATETHREAD:   Form1.Caption := 'Sample 摜荞ݗpXbh쐬Ɏs';
          ARTCAMSDK_CREATEWINDOW:   Form1.Caption := 'Sample EBhE쐬Ɏs';
          ARTCAMSDK_OUTOFMEMORY:    Form1.Caption := 'Sample C[W]ɏ\ȃmۂĂȂ@́@̊mۂɎs';
          ARTCAMSDK_CAMERASET:      Form1.Caption := 'Sample JifoCXj̐ݒŃG[';
          ARTCAMSDK_CAPTURE:        Form1.Caption := 'Sample f荞݂Ŏs';
          ARTCAMSDK_PARAM:          Form1.Caption := 'Sample ԈĂ܂';
          ARTCAMSDK_DIRECTSHOW:     Form1.Caption := 'Sample DirectShow G[';
          ARTCAMSDK_UNSUPPORTED:    Form1.Caption := 'Sample ̋@\̓T|[gĂ܂';
          ARTCAMSDK_UNKNOWN:        Form1.Caption := 'Sample s̃G[';
          ARTCAMSDK_CAPTURELOST:    Form1.Caption := 'Sample foCX܂';
        end;
      end;
    end;
  end;

  result := CallNextHookEx(Hook, code, wparam, lparam);
end;


//////////////////////////////////////////////////
// J
//////////////////////////////////////////////////
procedure TForm1.FormCreate(Sender: TObject);
begin
  // NX\z
  ArtCam1 := TArtCam.Create;

  // tbNłckk̃bZ[W󂯎
  Hook := SetWindowsHookEx(WH_GETMESSAGE, MsgProc, 0, GetCurrentThreadID);

  PreviewMode := 1;
  Timer1.Enabled := false;
  DllChange(Sender, 5);
end;


//////////////////////////////////////////////////
// JJ
//////////////////////////////////////////////////
procedure TForm1.FormDestroy(Sender: TObject);
begin
  ArtCam1.Release();

  UnHookWindowsHookEx(Hook);
end;


//////////////////////////////////////////////////
// 摜ۑ
//////////////////////////////////////////////////
procedure TForm1.SaveClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  ArtCam1.SaveImage('image.png', FILETYPE_PNG);
end;


//////////////////////////////////////////////////
// I
//////////////////////////////////////////////////
procedure TForm1.ExitClick(Sender: TObject);
begin
  CLose;
end;


//////////////////////////////////////////////////
// vr[
//////////////////////////////////////////////////
procedure TForm1.PreviewClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  ArtCam1.Close;
  ArtCam1.SetPreviewWindow(Form1.Handle, 0, 0, Form1.Width, Form1.Height);
  ArtCam1.Preview;

  // j[`FbN
  ShowPreview.Checked := true;
  ShowCallBack.Checked := false;
  ShowCapture.Checked := false;
  ShowTrigger.Checked := false;

  Invalidate;
  PreviewMode := 0;
end;


//////////////////////////////////////////////////
// R[obN
//////////////////////////////////////////////////
procedure TForm1.CallBackClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  ArtCam1.Close;
  CreateBitmap;
  ArtCam1.SetPreviewWindow(Form1.Handle, 0, 0, 0, 0);
  ArtCam1.CallBackPreview(Form1.Handle, BmpDraw.ScanLine[BmpDraw.Height-1], ArtCamGetSize, FALSE);

  // j[`FbN
  ShowPreview.Checked := false;
  ShowCallBack.Checked := true;
  ShowCapture.Checked := false;
  ShowTrigger.Checked := false;

  Invalidate;
  PreviewMode := 1;
end;


//////////////////////////////////////////////////
// XibvVbg
//////////////////////////////////////////////////
procedure TForm1.SnapShotClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  ArtCam1.Close;
  CreateBitmap;
  ArtCam1.SnapShot(BmpDraw.ScanLine[BmpDraw.Height-1], ArtCamGetSize, FALSE);
  DrawImage;

  // j[`FbN
  ShowPreview.Checked := false;
  ShowCallBack.Checked := false;
  ShowCapture.Checked := false;
  ShowTrigger.Checked := false;

//Invalidate;
  PreviewMode := -1;
end;


//////////////////////////////////////////////////
// Lv`
//////////////////////////////////////////////////
procedure TForm1.CaptureClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  ArtCam1.Close;
  CreateBitmap;
  ArtCam1.Capture;

  Timer1.Interval := 200;
  Timer1.Enabled := true;

  // j[`FbN
  ShowPreview.Checked := false;
  ShowCallBack.Checked := false;
  ShowCapture.Checked := true;
  ShowTrigger.Checked := false;

  Invalidate;
  PreviewMode := 3;
end;


//////////////////////////////////////////////////
// gK[
//////////////////////////////////////////////////
procedure TForm1.TriggerClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  ArtCam1.Close;
  CreateBitmap;
  ArtCam1.SetPreviewWindow(Form1.Handle, 0, 0, 0, 0);
  ArtCam1.Trigger(Form1.Handle, BmpDraw.ScanLine[BmpDraw.Height-1], ArtCamGetSize, FALSE);

  // j[`FbN
  ShowPreview.Checked := false;
  ShowCallBack.Checked := false;
  ShowCapture.Checked := false;
  ShowTrigger.Checked := true;

  Invalidate;
  PreviewMode := 4;
end;


//////////////////////////////////////////////////
// rbg}bv쐬
//////////////////////////////////////////////////
procedure TForm1.CreateBitmap;
var
  pal: TMaxLogPalette;
  i: Integer;
begin
  // \p̈
  BmpDraw := TBitmap.Create;
  BmpDraw.Width := ArtCamGetWidth;
  BmpDraw.Height := ArtCamGetHeight;

  case ArtCamGetBpp of
    1: begin
      BmpDraw.PixelFormat := pf8bit;

      // WrbgmN̏ꍇ̓pbg쐬
      for i := 0 to 255 do begin
        pal.palPalEntry[i].peRed   := i;
        pal.palPalEntry[i].peGreen := i;
        pal.palPalEntry[i].peBlue  := i;
        pal.palPalEntry[i].peFlags := 0;
      end;

      pal.palNumEntries := 256;
      pal.palVersion := $0300;
      BmpDraw.Palette := CreatePalette(PLogPalette(@pal)^);
    end;

    // QSrbgJ[
    3: begin
      BmpDraw.PixelFormat := pf24bit;
    end;
  end;

  // ȊO̐Fgpꍇ
  // Sample_Delphi7_Graphic&Allbpp
  // QƂɂĂ

end;


//////////////////////////////////////////////////
// \
//////////////////////////////////////////////////
procedure TForm1.DrawImage;
begin
  if BmpDraw=nil then begin exit; end;
  if BmpDraw.Empty then begin exit; end;

  // 摜`
  Canvas.Draw(0, 0, BmpDraw);
end;


//////////////////////////////////////////////////
// J̃TCY擾
//////////////////////////////////////////////////
function TForm1.ArtCamGetWidth: Integer;
begin
  result := ArtCam1.Width div SUB_SAMPLE[LONG(ArtCam1.GetSubSample)];
end;

function TForm1.ArtCamGetHeight: Integer;
begin
  result := ArtCam1.Height div SUB_SAMPLE[LONG(ArtCam1.GetSubSample)];
end;

function TForm1.ArtCamGetColor: Integer;
begin
  result := ((ArtCam1.GetColorMode + 7) div 8) * 8;
end;

function TForm1.ArtCamGetBpp: Integer;
begin
  result := ((ArtCam1.GetColorMode + 7) div 8);
end;

function TForm1.ArtCamGetSize: Integer;
begin
  result := ArtCamGetWidth * ArtCamGetHeight * ArtCamGetBpp;
end;


//////////////////////////////////////////////////
// Jݒ
//////////////////////////////////////////////////
procedure TForm1.SetCameraClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  ArtCam1.SetCameraDlg(Form1.Handle);

  case PreviewMode of
  0: PreviewClick(Sender);
  1: CallBackClick(Sender);
  3: CaptureClick(Sender);
  4: TriggerClick(Sender);
  end;
end;


//////////////////////////////////////////////////
// tB^[ݒ
//////////////////////////////////////////////////
procedure TForm1.SetFilterClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  ArtCam1.SetImageDlg(Form1.Handle);
end;


//////////////////////////////////////////////////
// AiOݒ
//////////////////////////////////////////////////
procedure TForm1.SetAnalogClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  ArtCam1.SetAnalogDlg(Form1.Handle);
end;


//////////////////////////////////////////////////
// foCXύX
//////////////////////////////////////////////////
procedure TForm1.DeviceChange(Sender: TObject; Number: Integer);
begin
  ArtCam1.Close;
  ArtCam1.SetDeviceNumber(Number);
  Timer1.Enabled := false;

  case PreviewMode of
  0: PreviewClick(Sender);
  1: CallBackClick(Sender);
  3: CaptureClick(Sender);
  4: TriggerClick(Sender);
  end;
end;


//////////////////////////////////////////////////
// foCXI
//////////////////////////////////////////////////
procedure TForm1.Device0Click(Sender: TObject); begin DeviceChange(Sender, 0); end;
procedure TForm1.Device1Click(Sender: TObject); begin DeviceChange(Sender, 1); end;
procedure TForm1.Device2Click(Sender: TObject); begin DeviceChange(Sender, 2); end;
procedure TForm1.Device3Click(Sender: TObject); begin DeviceChange(Sender, 3); end;
procedure TForm1.Device4Click(Sender: TObject); begin DeviceChange(Sender, 4); end;
procedure TForm1.Device5Click(Sender: TObject); begin DeviceChange(Sender, 5); end;
procedure TForm1.Device6Click(Sender: TObject); begin DeviceChange(Sender, 6); end;
procedure TForm1.Device7Click(Sender: TObject); begin DeviceChange(Sender, 7); end;
procedure TForm1.Device8Click(Sender: TObject); begin DeviceChange(Sender, 8); end;
procedure TForm1.Device9Click(Sender: TObject); begin DeviceChange(Sender, 9); end;


//////////////////////////////////////////////////
// DLLύX
//////////////////////////////////////////////////
procedure TForm1.DllChange(Sender: TObject; Number: Integer);
const
  DllNameList: array[0..14, 0..63] of AnsiChar = (
      'ArtCamSdk.dll',
      '',
      'ArtCamSdk_USTC.dll',
      'ArtCnvSdk.dll',
      '',
      'ArtCamSdk_130MI.dll',
      'ArtCamSdk_200MI.dll',
      'ArtCamSdk_300MI.dll',
      'ArtCamSdk_150P.dll',
      'ArtCamSdk_320P.dll',
      'ArtCamSdk_200SH.dll',
      'ArtCamSdk_098.dll',
      'ArtCamSdk_036MI.dll',
      'ArtCamSdk_500P.dll',
      'ArtCamSdk_150P2.dll'
    );

var
  DevName: DeviceNameList;
  DevCount: LONG;
  i: Integer;
  Temp: THandle;
begin
  // USĊJ
  if ArtCam1.IsInit then begin
    ArtCam1.Release;
    Timer1.Enabled := false;
  end;


  // DLL̗L`FbN
  for i := 0 to 14 do begin
    Temp := Windows.LoadLibrary(DllNameList[i]);
    if Temp<>0 then begin
      Windows.FreeLibrary(Temp);
      PopupDll[i].Enabled := true;
    end
    else begin
      PopupDll[i].Enabled := false;
    end;

    PopupDll[i].Checked := false;
  end;


  // DLLǂݍ
  if ArtCam1.LoadLibrary(DllNameList[LONG(Number)]) then
    // DLLꍇ
    begin
      PopupDll[LONG(Number)].Checked := true;

      ArtCam1.Initialize(Form1.Handle);
      DevCount := ArtCam1.EnumDevice(DevName);

      for i := 0 to DevCount-1 do begin
        ArtCam1.GetDeviceName(i, DevName[i], 256);
        PopupDevice[i].Caption := DevName[i];
        PopupDevice[i].Enabled := true;
      end;

      for i := DevCount to 9 do begin
        PopupDevice[i].Caption := IntToStr(i);
        PopupDevice[i].Enabled := false;
      end;

      case PreviewMode of
      0: PreviewClick(Sender);
      1: CallBackClick(Sender);
      3: CaptureClick(Sender);
      4: TriggerClick(Sender);
      end;

    end
  else
    // DLLȂꍇ
    begin
      for i := 0 to 9 do begin
        PopupDevice[i].Caption := IntToStr(i);
        PopupDevice[i].Enabled := false;
      end;
    end
end;


//////////////////////////////////////////////////
// DLLI
//////////////////////////////////////////////////
procedure TForm1.DSCameraClick   (Sender: TObject); begin DllChange(Sender, 0);  end;
procedure TForm1.ARTUSTClick     (Sender: TObject); begin DllChange(Sender, 2);  end;
procedure TForm1.ARTCNVClick     (Sender: TObject); begin DllChange(Sender, 3);  end;
procedure TForm1.ARTCAM130MIClick(Sender: TObject); begin DllChange(Sender, 5);  end;
procedure TForm1.ARTCAM200MIClick(Sender: TObject); begin DllChange(Sender, 6);  end;
procedure TForm1.ARTCAM300MIClick(Sender: TObject); begin DllChange(Sender, 7);  end;
procedure TForm1.ARTCAM150PClick (Sender: TObject); begin DllChange(Sender, 8);  end;
procedure TForm1.ARTCAM320PClick (Sender: TObject); begin DllChange(Sender, 9);  end;
procedure TForm1.ARTCAM200SHClick(Sender: TObject); begin DllChange(Sender, 10); end;
procedure TForm1.ARTCAM098Click  (Sender: TObject); begin DllChange(Sender, 11); end;
procedure TForm1.ARTCAM036MIClick(Sender: TObject); begin DllChange(Sender, 12); end;
procedure TForm1.ARTCAM500PClick (Sender: TObject); begin DllChange(Sender, 13); end;
procedure TForm1.ARTCAM150P2Click(Sender: TObject); begin DllChange(Sender, 14); end;


//////////////////////////////////////////////////
// Lv`p
//////////////////////////////////////////////////
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  ArtCam1.SnapShot(BmpDraw.ScanLine[ArtCam1.Height-1], ArtCamGetSize, FALSE);
  DrawImage;
end;


//////////////////////////////////////////////////
// EBhETCYύX
//////////////////////////////////////////////////
procedure TForm1.FormResize(Sender: TObject);
var
  Child: HWND;
  rc:  TRect;
{
  winW: Double;
  winH: Double;
  capW: Double;
  capH: Double;
}
begin
  // vr[[h̍ۂ͂rcjō쐬ꂽqEBhẼTCYςƕ\TCYς܂
  if PreviewMode = 0 then begin
    Child := GetWindow(Form1.Handle, GW_CHILD);
    rc := GetClientRect();

    // AXyNgςȂꍇ͂̃̕RgOĂ
{
    // vZ͏PʂɂȂ̂ňUɂ܂
    winW := rc.Right;
    winH := rc.Bottom;
    capW := ArtCamGetWidth;
    capH := ArtCamGetHeight;

    if (winW * capH) > (winH * capW) then begin
      winW := winH * capW / capH;
      rc.Right := Trunc(winW);
    end
    else
    if (winW * capH) < (winH * capW) then begin
      winH := winW * capH / capW;
      rc.Bottom := Trunc(winH);
    end;
 }

    SetWindowPos(Child, HWND_TOP, 0, 0, rc.Right, rc.Bottom, SWP_NOMOVE or SWP_NOZORDER or SWP_SHOWWINDOW);
  end;
end;

end.

