// Sample_MFCView.cpp : CSample_MFCView NX̓̒`s܂B
//

#include "stdafx.h"
#include "Sample_MFC.h"
#include "MainFrm.h"

#include "Sample_MFCDoc.h"
#include "Sample_MFCView.h"

#include "SetFilterDlg.h"
#include "SetSizeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define CAP_TIMER_ID	100
#define REC_TIMER_ID	200
#define TIMER_TIME		50

const int SUB_SAMPLE[] = { 1, 2, 4, 8 };
#define ArtCamGetWidth()	(m_CArtCamSdk.Width()  / SUB_SAMPLE[m_CArtCamSdk.GetSubSample()])
#define ArtCamGetHeight()	(m_CArtCamSdk.Height() / SUB_SAMPLE[m_CArtCamSdk.GetSubSample()])
#define ArtCamGetColor()	WORD(((m_CArtCamSdk.GetColorMode() + 7) / 8) * 8)
#define ArtCamGetBpp()		(((m_CArtCamSdk.GetColorMode() + 7) / 8))
#define ArtCamGetPitch()	((ArtCamGetWidth() * ArtCamGetBpp() + 3) & ~3)
#define ArtCamGetSize()		(ArtCamGetPitch() * ArtCamGetHeight())
#define SAFE_DELETE(x)  { if(x) delete[] x; x=NULL; }



/////////////////////////////////////////////////////////////////////////////
// CSample_MFCView

IMPLEMENT_DYNCREATE(CSample_MFCView, CView)

BEGIN_MESSAGE_MAP(CSample_MFCView, CView)
	//{{AFX_MSG_MAP(CSample_MFCView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_MOUSEMOVE()
	ON_MESSAGE(WM_GRAPHPAINT, OnGraphPaint)
	ON_MESSAGE(WM_ERROR, OnError)
	ON_COMMAND(ID_FILE_SAVEIMAGE, OnFileSaveimage)
	ON_COMMAND(ID_FILE_REC, OnFileRec)
	ON_COMMAND(ID_FILE_EXIT, OnExit)
	ON_COMMAND(ID_SHOW_PREVIEW, OnShowPreview)
	ON_COMMAND(ID_SHOW_CALLBACK, OnShowCallback)
	ON_COMMAND(ID_SHOW_SNAPSHOT, OnShowSnapshot)
	ON_COMMAND(ID_SHOW_CAPTURE, OnShowCapture)
	ON_COMMAND(ID_SHOW_TRIGGER, OnShowTrigger)
	ON_COMMAND(ID_SHOW_STOP, OnShowStop)
	ON_COMMAND(ID_SET_FORMAT, OnSetFormat)
	ON_COMMAND(ID_SET_FILTER, OnSetFilter)
	ON_COMMAND(ID_SET_ANALOG, OnSetAnalog)
	ON_COMMAND(ID_SET_FILTER_APP, OnSetFilterApp)
	ON_COMMAND(ID_DLL_CAM, OnDllCam)
	ON_COMMAND(ID_DLL_USTC, OnDllUstc)
	ON_COMMAND(ID_DLL_CNV, OnDllCnv)
	ON_COMMAND(ID_DLL_130MI, OnDll130mi)
	ON_COMMAND(ID_DLL_200MI, OnDll200mi)
	ON_COMMAND(ID_DLL_300MI, OnDll300mi)
	ON_COMMAND(ID_DLL_150P, OnDll150p)
	ON_COMMAND(ID_DLL_320P, OnDll320p)
	ON_COMMAND(ID_DLL_200SH, OnDll200sh)
	ON_COMMAND(ID_DLL_098, OnDll098)
	ON_COMMAND(ID_DLL_036MI, OnDll036mi)
	ON_COMMAND(ID_DLL_500P, OnDll500p)
	ON_COMMAND(ID_DLL_150P2, OnDll150p2)
	ON_COMMAND(ID_DEVICE01, OnDevice01)
	ON_COMMAND(ID_DEVICE02, OnDevice02)
	ON_COMMAND(ID_DEVICE03, OnDevice03)
	ON_COMMAND(ID_DEVICE04, OnDevice04)
	ON_COMMAND(ID_DEVICE05, OnDevice05)
	ON_COMMAND(ID_DEVICE06, OnDevice06)
	ON_COMMAND(ID_DEVICE07, OnDevice07)
	ON_COMMAND(ID_DEVICE08, OnDevice08)
	ON_COMMAND(ID_SET_SIZE_APP, OnSetSizeApp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSample_MFCView NX̍\z/

CSample_MFCView::CSample_MFCView()
{
	theApp.m_pView = this;


	m_pImage = NULL;
	m_PreviewMode = -1;
	m_DllType = -1;
	m_DeviceCount = 0;
	m_SelectDevice = -1;

	m_SaveFlg = FALSE;
	m_StopFlg = FALSE;
}

CSample_MFCView::~CSample_MFCView()
{
}

BOOL CSample_MFCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
	cs.style |= WS_HSCROLL;
	cs.style |= WS_VSCROLL;

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSample_MFCView NX̕`

void CSample_MFCView::OnDraw(CDC* pDC)
{
	CSample_MFCDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);


	if(0 != m_PreviewMode){
		DrawImage(pDC->m_hDC);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSample_MFCView NX̐ff

#ifdef _DEBUG
void CSample_MFCView::AssertValid() const
{
	CView::AssertValid();
}

void CSample_MFCView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSample_MFCDoc* CSample_MFCView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSample_MFCDoc)));
	return (CSample_MFCDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSample_MFCView NX̃bZ[W nh

int CSample_MFCView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;


	// OgĂDLLŏɓǂݍ
	TCHAR szFilePath[MAX_PATH]="";
	TCHAR szExePath[3][MAX_PATH]={"","",""};
	GetModuleFileName(::GetModuleHandle(NULL), szExePath[0], MAX_PATH);
	_splitpath(szExePath[0], szExePath[1], szExePath[2], NULL, NULL);
	wsprintf(szFilePath, "%s%sSample.ini", szExePath[1], szExePath[2]);

	m_DllType = ::GetPrivateProfileInt("Sample", "DllType", -1, szFilePath);


	// DLL邩`FbN
	CMenu* pMenu = GetParent()->GetMenu();
	CMenu* pDllMenu = pMenu->GetSubMenu(3);
	for(int i=0; i<DLLCOUNT; i++){
		m_MenuEnable[i] = TRUE;

		CArtCamSdk ArtCam;
		if(ArtCam.LoadLibrary(const_cast<LPTSTR>(DLLNAMELIST[i]))){
			CString strd, strv;

			// o[W擾ĕ\܂
			pDllMenu->GetMenuString(i, strd, MF_BYPOSITION);
			strv.Format("\tVersion %04d", LOWORD(ArtCam.GetDllVersion()));
			strd += strv;

			pDllMenu->ModifyMenu(i, MF_BYPOSITION | MF_STRING, pDllMenu->GetMenuItemID(i), strd);
		}
		// DLL
		else {
			m_MenuEnable[i] = FALSE;
		}
	}


	// J̏
	if(-1 != m_DllType)
		OnDllChange(m_DllType);

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_DESTROY
//

void CSample_MFCView::OnDestroy() 
{
	CView::OnDestroy();

	TCHAR szFilePath[MAX_PATH]="";
	TCHAR szExePath[3][MAX_PATH]={"","",""};
	GetModuleFileName(::GetModuleHandle(NULL), szExePath[0], MAX_PATH);
	_splitpath(szExePath[0], szExePath[1], szExePath[2], NULL, NULL);
	wsprintf(szFilePath, "%s%sSample.ini", szExePath[1], szExePath[2]);


	TCHAR Data[32]="";
	wsprintf(Data, "%d", m_DllType);
	::WritePrivateProfileString("Sample", "DllType", Data, szFilePath);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_GRAPHPAINT
//

void CSample_MFCView::OnGraphPaint(WPARAM wParam, LPARAM lParam)
{
	// ̃bZ[W_ m_pImage ɂ͍ŐV̉fi[Ă
	LPGP_INFO pGpInfo = (LPGP_INFO)wParam;
	DrawImage(NULL);


	CString Fps;
	Fps.Format("%.1f", double(pGpInfo->lFps) / 10.0);
	static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_FRAME, Fps);

	m_SaveFlg = TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_ERROR
//

void CSample_MFCView::OnError(WPARAM wParam, LPARAM lParam)
{
	if(0 <= lParam && lParam < ERRORCOUNT-1){
		static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_TEXT, ERRORLIST[lParam]);
	}
	else {
		static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_TEXT, ERRORLIST[ERRORCOUNT-1]);
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Î~ۑ
//

void CSample_MFCView::OnFileSaveimage()
{
	CFileDialog FD(FALSE, NULL, "t@CI", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"BITMAPt@C(*.bmp)|*.bmp|JPEGt@C(*.jpg)|*.jpg;*.jpeg|TIFFt@C(*.tif)|*.tif;*.tiff|PNGt@C(*.png)|*.png|RAWt@C(*.raw)|*.raw||", this);

	if(IDOK == FD.DoModal()){
		OPENFILENAME ofn = FD.m_ofn;

		// gq͎Őݒ肳
		TCHAR szTemp[4][MAX_PATH]={"","","",""};
		_splitpath(ofn.lpstrFile, szTemp[0], szTemp[1], szTemp[2], szTemp[3]);

		CString str;
		switch(ofn.nFilterIndex){
		case 1:	str.Format("%s%s%s.bmp", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_BITMAP);		break;
		case 2:	str.Format("%s%s%s.jpg", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_JPEG_HIGH);	break;
		case 3:	str.Format("%s%s%s.tif", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_TIFF);			break;
		case 4:	str.Format("%s%s%s.png", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_PNG);			break;
		case 5:	str.Format("%s%s%s.raw", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_RAW);			break;
		break;
		}
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	ۑ(DirectShowł̂)
//

void CSample_MFCView::OnFileRec()
{
	CFileDialog FD(FALSE, "avi", "t@CI", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "AVIt@C(*.avi)|*.avi||", this);

	if(IDOK == FD.DoModal()){
		m_RecName = FD.GetPathName();

		// U~
		m_CArtCamSdk.Close();

		// ^撆͕ʃEBhEɕ\Ă݂
		// hWndNULLꍇSDKŃEBhEôŃTCY͂܂֌WȂ
		m_CArtCamSdk.SetPreviewWindow(NULL, 0, 0, 0, 0);

		// TbԘ^
		m_CArtCamSdk.Record(m_RecName, 5000, 1);


		// ^Ĩ^C~OSDK瑗ĂȂ̂ŁA\tgŎ~߂
		// Ô߂Pb߂Ƀ^C}[܂킷
		SetTimer(REC_TIMER_ID, 6000, NULL);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	I
//

void CSample_MFCView::OnExit()
{
	PostMessage(WM_CLOSE);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	摜`
//

struct BITMAPINFO2 {
	BITMAPINFOHEADER   bmiHeader;
	RGBQUAD            bmiColors[256];
};

LRESULT CSample_MFCView::DrawImage(HDC hDC)
{
	if(NULL == m_pImage){
		return 0;
	}

	BOOL Flg = FALSE;
	if(NULL == hDC){
		hDC = ::GetDC(m_hWnd);
		Flg = TRUE;
	}

	CPoint Pos;
	Pos.x = GetScrollPos(SB_HORZ);
	Pos.y = GetScrollPos(SB_VERT);


	if(hDC){
		LONG Width = ArtCamGetWidth();
		LONG Height = ArtCamGetHeight();
		LONG Bpp = ArtCamGetBpp();

		BITMAPINFO2 bm;
		bm.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bm.bmiHeader.biPlanes = 1;
		bm.bmiHeader.biCompression = BI_RGB;
		bm.bmiHeader.biSizeImage = 0;
		bm.bmiHeader.biXPelsPerMeter = 0;
		bm.bmiHeader.biYPelsPerMeter = 0;
		bm.bmiHeader.biClrUsed = 0;
		bm.bmiHeader.biClrImportant = 0;

		bm.bmiHeader.biWidth = Width;
		bm.bmiHeader.biHeight = Height;


		// mNWrbg摜]
		if(1 == Bpp){
			bm.bmiHeader.biBitCount = 8;

			for(int i=0; i<256; i++){
				bm.bmiColors[i].rgbRed = i;
				bm.bmiColors[i].rgbGreen = i;
				bm.bmiColors[i].rgbBlue = i;
				bm.bmiColors[i].rgbReserved = 0;
			}
			::SetDIBColorTable(hDC, 0, 256, bm.bmiColors);

			SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
								0, 0, 0, bm.bmiHeader.biHeight, m_pImage, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
		}

		// mNPOrbg^PUrbg摜]
		else if(2 == Bpp){
			bm.bmiHeader.biBitCount = 8;

			for(int i=0; i<256; i++){
				bm.bmiColors[i].rgbRed = i;
				bm.bmiColors[i].rgbGreen = i;
				bm.bmiColors[i].rgbBlue = i;
				bm.bmiColors[i].rgbReserved = 0;
			}
			::SetDIBColorTable(hDC, 0, 256, bm.bmiColors);

			LPBYTE pTemp = new BYTE[bm.bmiHeader.biWidth * bm.bmiHeader.biHeight];
			if(pTemp){
				for(int y=0; y<bm.bmiHeader.biHeight; y++){

					LPBYTE pDest =        pTemp     + (y * bm.bmiHeader.biWidth);
					LPWORD pSrc  = LPWORD(m_pImage) + (y * bm.bmiHeader.biWidth);

					for(int x=0; x<bm.bmiHeader.biWidth; x++){
						pDest[0] = BYTE(pSrc[0] >> 2);

						pDest++;
						pSrc ++;
					}
				}


				SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
									0, 0, 0, bm.bmiHeader.biHeight, pTemp, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
				delete[] pTemp;
			}
		}

		// J[QSrbg]
		else if(3 == Bpp){
			bm.bmiHeader.biBitCount = 24;
			SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
								0, 0, 0, bm.bmiHeader.biHeight, m_pImage, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
		}

		// J[RQrbg]
		else if(4 == Bpp){
			bm.bmiHeader.biBitCount = 24;

			LPBYTE pTemp = new BYTE[bm.bmiHeader.biWidth * bm.bmiHeader.biHeight * 3];
			if(pTemp){
				for(int y=0; y<bm.bmiHeader.biHeight; y++){

					LPBYTE pDest = pTemp    + (y * bm.bmiHeader.biWidth * 3);
					LPBYTE pSrc  = m_pImage + (y * bm.bmiHeader.biWidth * 4);

					for(int x=0; x<bm.bmiHeader.biWidth; x++){
						pDest[0] = pSrc[0];
						pDest[1] = pSrc[1];
						pDest[2] = pSrc[2];

						pDest+=3;
						pSrc +=4;
					}
				}


				SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
									0, 0, 0, bm.bmiHeader.biHeight, pTemp, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
				delete[] pTemp;
			}
		}

		// J[SWAUSrbg]
		else if(6 == Bpp || 8 == Bpp){
			bm.bmiHeader.biBitCount = 24;
			Bpp /= 2;

			LPBYTE pTemp = new BYTE[bm.bmiHeader.biWidth * bm.bmiHeader.biHeight * 3];
			if(pTemp){
				for(int y=0; y<bm.bmiHeader.biHeight; y++){

					LPBYTE pDest =        pTemp     + (y * bm.bmiHeader.biWidth * 3);
					LPWORD pSrc  = LPWORD(m_pImage) + (y * bm.bmiHeader.biWidth * Bpp);

					for(int x=0; x<bm.bmiHeader.biWidth; x++){
						pDest[0] = BYTE(pSrc[0] >> 2);
						pDest[1] = BYTE(pSrc[1] >> 2);
						pDest[2] = BYTE(pSrc[2] >> 2);

						pDest+=3;
						pSrc +=Bpp;
					}
				}


				SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
									0, 0, 0, bm.bmiHeader.biHeight, pTemp, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
				delete[] pTemp;
			}
		}


		if(Flg){
			::ReleaseDC(m_hWnd, hDC);
		}

		return 1;
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	rcjŕ`
//

void CSample_MFCView::OnShowPreview()
{
	// DLLI
	if(-1 == m_DllType){
		AfxMessageBox("ڑĂJDLLIĂ");
		return;
	}

	// ^C}[폜
	if(3 == m_PreviewMode){
		KillTimer(CAP_TIMER_ID);
	}

	// ňUfoCXJ
	m_CArtCamSdk.Close();


	// fp̗̈J
	SAFE_DELETE(m_pImage);


	// \EBhEݒ肷
	// hWnd NULLݒ肷ƐVEBhE쐬ĕ\܂
	CRect rc;
	GetClientRect(&rc);
	m_CArtCamSdk.SetPreviewWindow(m_hWnd, 0, 0, rc.right, rc.bottom);


	// f\
	m_CArtCamSdk.Preview();


	// j[`FbN
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_CHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_UNCHECKED);

	m_PreviewMode = 0;
	m_SaveFlg = TRUE;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "ꎞ~");

	ChangeScrollbar();
	Invalidate();
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	f̃|C^擾ăAvP[Vŕ`悷
//

void CSample_MFCView::OnShowCallback()
{
	// DLLI
	if(-1 == m_DllType){
		AfxMessageBox("ڑĂJDLLIĂ");
		return;
	}

	// ^C}[폜
	if(3 == m_PreviewMode){
		KillTimer(CAP_TIMER_ID);
	}

	// ňUfoCXJ
	m_CArtCamSdk.Close();


	// fp̗̈J
	SAFE_DELETE(m_pImage);


	// ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
	// CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
	m_CArtCamSdk.SetPreviewWindow(m_hWnd, 0, 0, 0, 0);


	// 荞ݗp̈m
	m_pImage = new BYTE[ArtCamGetSize()];

	m_CArtCamSdk.CallBackPreview(m_hWnd, m_pImage, ArtCamGetSize(), 0);


	// j[`FbN
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_CHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_UNCHECKED);

	m_PreviewMode = 1;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "ꎞ~");

	ChangeScrollbar();
	Invalidate();
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	ꖇ摜\
//

void CSample_MFCView::OnShowSnapshot()
{
	// DLLI
	if(-1 == m_DllType){
		AfxMessageBox("ڑĂJDLLIĂ");
		return;
	}

	// ^C}[폜
	if(3 == m_PreviewMode){
		KillTimer(CAP_TIMER_ID);
	}

	// ňUfoCXJ
	m_CArtCamSdk.Close();


	// fp̗̈J
	SAFE_DELETE(m_pImage);

	// 荞ݗp̈m
	m_pImage = new BYTE[ArtCamGetSize()];

	m_CArtCamSdk.SnapShot(m_pImage, ArtCamGetSize(), 0);
	m_SaveFlg = TRUE;


	// 摜`
	DrawImage(NULL);

	// j[`FbN
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_UNCHECKED);

	m_PreviewMode = -1;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "ꎞ~");
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	rcjŕ`
//

void CSample_MFCView::OnShowCapture()
{
	// DLLI
	if(-1 == m_DllType){
		AfxMessageBox("ڑĂJDLLIĂ");
		return;
	}


	// ňUfoCXJ
	m_CArtCamSdk.Close();

	// fp̗̈J
	SAFE_DELETE(m_pImage);

	// 荞ݗp̈m
	m_pImage = new BYTE[ArtCamGetSize()];

	m_CArtCamSdk.Capture();


	// j[`FbN
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_CHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_UNCHECKED);

	m_PreviewMode = 3;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "ꎞ~");

	ChangeScrollbar();
	Invalidate();

	SetTimer(CAP_TIMER_ID, TIMER_TIME, NULL);
}


void CSample_MFCView::OnTimer(UINT nIDEvent)
{
	if(3 == m_PreviewMode && CAP_TIMER_ID == nIDEvent){
		KillTimer(CAP_TIMER_ID);

		m_CArtCamSdk.SnapShot(m_pImage, ArtCamGetSize(), 0);
		m_SaveFlg = TRUE;

		// 摜`
		DrawImage(NULL);

		SetTimer(CAP_TIMER_ID, TIMER_TIME, NULL);
	}

	// ^I
	if(REC_TIMER_ID == nIDEvent){
		m_CArtCamSdk.Close();
		KillTimer(REC_TIMER_ID);

		if(IDYES == MessageBox("^悪܂B\nۑt@CĐ܂H", "^抮", MB_YESNO | MB_ICONQUESTION)){
			::ShellExecute(NULL, NULL, m_RecName, NULL, NULL, SW_SHOWNORMAL);
		}
	}

	CView::OnTimer(nIDEvent);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	gK[[h
//

void CSample_MFCView::OnShowTrigger()
{
	// DLLI
	if(-1 == m_DllType){
		AfxMessageBox("ڑĂJDLLIĂ");
		return;
	}

	// ^C}[폜
	if(3 == m_PreviewMode){
		KillTimer(CAP_TIMER_ID);
	}

	// ňUfoCXJ
	m_CArtCamSdk.Close();


	// fp̗̈J
	SAFE_DELETE(m_pImage);


	// ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
	// CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
	m_CArtCamSdk.SetPreviewWindow(m_hWnd, 0, 0, 0, 0);


	// 荞ݗp̈m
	m_pImage = new BYTE[ArtCamGetSize()];

	m_CArtCamSdk.Trigger(m_hWnd, m_pImage, ArtCamGetSize(), 0);


	// j[`FbN
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_CHECKED);

	m_PreviewMode = 4;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "ꎞ~");

	ChangeScrollbar();
	Invalidate();
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	\ꎞ~^ĊJ
//

void CSample_MFCView::OnShowStop()
{
	// ̎̂ݎ~߂
	if(0 == m_PreviewMode || 1 == m_PreviewMode){
		if(m_StopFlg){
			m_CArtCamSdk.StartPreview();
			m_StopFlg = FALSE;

			GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "ꎞ~");
		}
		else {
			m_CArtCamSdk.StopPreview();
			m_StopFlg = TRUE;

			GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "ĊJ");
		}
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	DLL؂ւ
//

BOOL CSample_MFCView::OnDllChange(LONG DllType)
{
	// ckk؂ւۂ͈USĊJ܂B
	// ̃J̓\sۂ CArtCamSdk 𕡐`Kv܂B
	// `Ăꍇ̓J؂ւ̍ۂɊJKv͂ȂȂ܂B
	m_CArtCamSdk.Release();
	m_CArtCamSdk.FreeLibrary();


	if(!m_CArtCamSdk.LoadLibrary(const_cast<LPTSTR>(DLLNAMELIST[DllType]))){
		CString Error;
		Error.Format("%s܂\nNDLLړ\܂", DLLNAMELIST[DllType]);
		AfxMessageBox(Error);
		return FALSE;
	}

	// Initialize ͍ŏɌĂт܂
	// ŃEBhEnhݒ肷WM_ERROR擾鎖o
	if(!m_CArtCamSdk.Initialize(m_hWnd)){
		AfxMessageBox("rcj̏Ɏs܂");
		return FALSE;
	}

	CMenu* pMenu = GetParent()->GetMenu();

	// j[`FbN
	CMenu* pDllMenu = pMenu->GetSubMenu(3);

	for(int i=0; i<DLLCOUNT; i++){
		pDllMenu->CheckMenuItem(i, MF_BYPOSITION | MF_UNCHECKED);
	}
	pDllMenu->CheckMenuItem(DllType, MF_BYPOSITION | MF_CHECKED);


	// foCXύXj[
	CMenu* pDeviceMenu = pMenu->GetSubMenu(4);

	TCHAR szName[10][256];
	TCHAR szDef[10][256] = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" };
	m_DeviceCount = m_CArtCamSdk.EnumDevice(szName);

	for(i=0; i<m_DeviceCount; i++){
		pDeviceMenu->ModifyMenu(i, MF_BYPOSITION | MF_STRING, ID_DEVICE01 + i, szName[i]);
	}
	for(; i<10; i++){
		pDeviceMenu->ModifyMenu(i, MF_BYPOSITION | MF_STRING, ID_DEVICE01 + i, szDef[i]);
	}

	m_SaveFlg = FALSE;

	// foCXݒ
	return OnDeviceChange(0);
}


void CSample_MFCView::OnDllCam()	{ m_DllType =  0; OnDllChange( 0); }
void CSample_MFCView::OnDllUstc()	{ m_DllType =  2; OnDllChange( 2); }
void CSample_MFCView::OnDllCnv()	{ m_DllType =  3; OnDllChange( 3); }
void CSample_MFCView::OnDll130mi()	{ m_DllType =  5; OnDllChange( 5); }
void CSample_MFCView::OnDll200mi()	{ m_DllType =  6; OnDllChange( 6); }
void CSample_MFCView::OnDll300mi()	{ m_DllType =  7; OnDllChange( 7); }
void CSample_MFCView::OnDll150p()	{ m_DllType =  8; OnDllChange( 8); }
void CSample_MFCView::OnDll320p()	{ m_DllType =  9; OnDllChange( 9); }
void CSample_MFCView::OnDll200sh()	{ m_DllType = 10; OnDllChange(10); }
void CSample_MFCView::OnDll098()	{ m_DllType = 11; OnDllChange(11); }
void CSample_MFCView::OnDll036mi()	{ m_DllType = 12; OnDllChange(12); }
void CSample_MFCView::OnDll500p()	{ m_DllType = 13; OnDllChange(13); }
void CSample_MFCView::OnDll150p2()	{ m_DllType = 14; OnDllChange(14); }


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	foCX؂ւ
//

BOOL CSample_MFCView::OnDeviceChange(LONG Number)
{
	// DLLI
	if(-1 == m_DllType){
		AfxMessageBox("ڑĂJDLLIĂ");
		return FALSE;
	}


	// foCXύXOɎgp̃foCXJ
	m_CArtCamSdk.Close();


	// foCXڑĂ邩`FbNꍇ
	// GetDeviceName gΊȒPɕ
	// AO擾̈悪ꍇG[ɂȂ̂Ŕz񒷂͍Œ32͗pӂ鎖
	TCHAR szName[256]="";
	if(!m_CArtCamSdk.GetDeviceName(Number, szName, 256)){
		m_PreviewMode = -1;
		m_SelectDevice = -1;
		m_StopFlg = FALSE;
		GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "ꎞ~");
		return FALSE;
	}


	// ŃfoCX̔ԍύXĂJ\ƃfoCXύX
	// F̊֐P̂ł̓foCX͕ύX܂B
	// @@̊֐ĂяoɃfoCX鎖ŃfoCXύX܂
	m_SelectDevice = Number;
	m_CArtCamSdk.SetDeviceNumber(Number);


	CMenu* pMenu = GetParent()->GetMenu();
	CMenu* pDeviceMenu = pMenu->GetSubMenu(4);

	for(int i=0; i<8; i++){
		pDeviceMenu->CheckMenuItem(i, MF_BYPOSITION | MF_UNCHECKED);
	}
	pDeviceMenu->CheckMenuItem(Number, MF_BYPOSITION | MF_CHECKED);


	switch(m_PreviewMode){
	case 0: OnShowPreview();  return TRUE;
	case 1: OnShowCallback(); return TRUE;
	case 3: OnShowCapture(); return TRUE;
	case 4: OnShowTrigger(); return TRUE;
	}

	return TRUE;
}

void CSample_MFCView::OnDevice01()	{ OnDeviceChange(0); }
void CSample_MFCView::OnDevice02()	{ OnDeviceChange(1); }
void CSample_MFCView::OnDevice03()	{ OnDeviceChange(2); }
void CSample_MFCView::OnDevice04()	{ OnDeviceChange(3); }
void CSample_MFCView::OnDevice05()	{ OnDeviceChange(4); }
void CSample_MFCView::OnDevice06()	{ OnDeviceChange(5); }
void CSample_MFCView::OnDevice07()	{ OnDeviceChange(6); }
void CSample_MFCView::OnDevice08()	{ OnDeviceChange(7); }


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	ݒEBhE
//

void CSample_MFCView::OnSetFormat()
{
	// {֐͕Kf~߂ĂgpĂB
	// ~߂ĂȂԂŃR[ꍇ
	// rcjŉf~߁A_CAO\ĊJ܂

	// ̎TCYύXꍇArcj̉fTCY͔f܂A
	// AvP[VŊmۂĂf[^XVȂƐf擾łȂꍇ܂

	m_CArtCamSdk.Close();
	m_CArtCamSdk.SetCameraDlg(m_hWnd);

	switch(m_PreviewMode){
	case 0: OnShowPreview();  return ;
	case 1: OnShowCallback(); return ;
	case 3: OnShowCapture(); return ;
	case 4: OnShowTrigger(); return ;
	}
}

void CSample_MFCView::OnSetFilter()
{
	// {֐͂ȂׂȂ瓮f\Ă󋵂
	// R[Ă
	// ~łݒ͏o܂AoȂgp@ł

	m_CArtCamSdk.SetImageDlg(m_hWnd);
}

void CSample_MFCView::OnSetAnalog()
{
	// {֐͂ȂׂȂ瓮f\Ă󋵂
	// R[Ă
	// ~łݒ͏o܂AoȂgp@ł

	m_CArtCamSdk.SetAnalogDlg(m_hWnd);
}

void CSample_MFCView::OnSetFilterApp()
{
	// Őݒp̊֐ʂɎgĂ܂B
	// ȂׂJڑꂽԂŎgpĉ

	// {Iɂ̓JqĂȂĂA
	// SDKŊǗĂ鐔l̐ݒ͏o܂A
	// SȎgł͂܂B

	CSetFilterDlg SFD;
	SFD.m_pCArtCamSdk = &m_CArtCamSdk;
	SFD.m_Preview = m_PreviewMode;
	SFD.DoModal();
}

void CSample_MFCView::OnSetSizeApp()
{
	m_CArtCamSdk.Close();

	CSetSizeDlg SSD;
	SSD.m_pCArtCamSdk = &m_CArtCamSdk;
	SSD.DoModal();

	switch(m_PreviewMode){
	case 0: OnShowPreview();  return ;
	case 1: OnShowCallback(); return ;
	case 3: OnShowCapture(); return ;
	case 4: OnShowTrigger(); return ;
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
//
//	j[
//

void CSample_MFCView::InitMenuPopup(CMenu* pPopupMenu)
{
	CMenu* pMenu = GetParent()->GetMenu();

	// t@Cۑ֘A
	if(pPopupMenu == pMenu->GetSubMenu(0)){
		// ۑ\ixłf荞܂ĂΉ\j
		if(m_SaveFlg){
			pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_ENABLED);
		} else {
			pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_GRAYED);
		}

		// DirectShowJ`FbN
		// ^@\̂DirectShowĴ
		if(0 == m_DllType){
			pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_ENABLED);
		} else {
			pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_GRAYED);
		}
	}

	// `֘A
	if(pPopupMenu == pMenu->GetSubMenu(1)){
		// foCXɐڑĂȂꍇ͍ĐoȂ
		if(-1 == m_SelectDevice){
			pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->EnableMenuItem(2, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->EnableMenuItem(3, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->EnableMenuItem(4, MF_BYPOSITION | MF_GRAYED);
		} else {
			pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_ENABLED);
			pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_ENABLED);
			pPopupMenu->EnableMenuItem(2, MF_BYPOSITION | MF_ENABLED);
			pPopupMenu->EnableMenuItem(3, MF_BYPOSITION | MF_ENABLED);

			// gK[[h͎gȂĴŒ
			switch(m_DllType){
			case 0:		// DS
			case 2:		// UST
			case 3:		// CNV
			case 10:	// 200SH
			case 11:	// 098
			case 13:	// 500P
				pPopupMenu->EnableMenuItem(4, MF_BYPOSITION | MF_GRAYED);
			break;

			default:
				pPopupMenu->EnableMenuItem(4, MF_BYPOSITION | MF_ENABLED);
			break;
			}
		}
	}

	// ݒEBhE̎gp\Ԃ̐؂ւ
	if(pPopupMenu == pMenu->GetSubMenu(2)){

		// DirectShowJ͋@ɂĎgpł邩ǂˑ܂
		// SetAnalogDlg͎gȂ@킪Ǝv܂̂ŒӂĂB
		pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_ENABLED);
		pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_ENABLED);

		switch(m_DllType){
//		case 0:		// DS
		case 2:		// UST
		case 3:		// CNV
			pPopupMenu->EnableMenuItem(2, MF_BYPOSITION | MF_GRAYED);
		break;

		default:
			pPopupMenu->EnableMenuItem(2, MF_BYPOSITION | MF_ENABLED);
		break;
		}
	}

	// gp\ckk
	if(pPopupMenu == pMenu->GetSubMenu(3)){
		for(int i=0; i<DLLCOUNT; i++){
			if(!m_MenuEnable[i]){
				pPopupMenu->EnableMenuItem(i, MF_BYPOSITION | MF_GRAYED);
			}
		}
	}

	// gp\foCX
	if(pPopupMenu == pMenu->GetSubMenu(4)){
		for(int i=0; i<m_DeviceCount; i++){
			pPopupMenu->EnableMenuItem(i, MF_BYPOSITION | MF_ENABLED);
			pPopupMenu->CheckMenuItem(i, MF_BYPOSITION | MF_UNCHECKED);
		}
		for(; i<10; i++){
			pPopupMenu->EnableMenuItem(i, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->CheckMenuItem(i, MF_BYPOSITION | MF_UNCHECKED);
		}

		pPopupMenu->CheckMenuItem(m_SelectDevice, MF_BYPOSITION | MF_CHECKED);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	
//

void CSample_MFCView::ChangeScrollbar(void)
{
	if(0 == m_PreviewMode){
		SetScrollPos(SB_HORZ, 0);
		SetScrollPos(SB_VERT, 0);
		ShowScrollBar(SB_HORZ, FALSE);
		ShowScrollBar(SB_VERT, FALSE);
		return;
	}


	CRect rc;
	GetClientRect(&rc);

	LONG lWidth  = ArtCamGetWidth();
	LONG lHeight = ArtCamGetHeight();

	LONG PosX = GetScrollPos(SB_HORZ);
	LONG PosY = GetScrollPos(SB_VERT);


	SCROLLINFO sc;
	sc.fMask	= SIF_RANGE | SIF_POS | SIF_PAGE;

	LONG OffsetH = 16;
	LONG OffsetV = 16;


	if(rc.right + OffsetH >= lWidth){
		ShowScrollBar(SB_HORZ, FALSE);
	} else {
		sc.nMin		= 0;
		sc.nMax		= lWidth;
		sc.nPage	= rc.right;
		sc.nPos		= PosX;
		SetScrollInfo(SB_HORZ, &sc);
	}

	if(rc.bottom + OffsetV >= lHeight){
		ShowScrollBar(SB_VERT, FALSE);
	} else {
		sc.nMin		= 0;
		sc.nMax		= lHeight;
		sc.nPage	= rc.bottom;
		sc.nPos		= PosY;
		SetScrollInfo(SB_VERT, &sc);
	}

	if(lWidth  - rc.right  < PosX)	SetScrollPos(SB_HORZ, lWidth  - rc.right);
	if(lHeight - rc.bottom < PosY)	SetScrollPos(SB_VERT, lHeight - rc.bottom);
	if(0.0 > PosX)					SetScrollPos(SB_HORZ, 0);
	if(0.0 > PosY)					SetScrollPos(SB_VERT, 0);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	TCYύX
//

void CSample_MFCView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	if(0 == m_PreviewMode){
		CWnd* pChild = GetWindow(GW_CHILD);

		CRect rc;
		GetClientRect(&rc);


		// AXyNgςȂꍇ͂̃̕RgOĂ

		// vZ͏PʂɂȂ̂ňU_^ɂĂ܂
		double winW = rc.right;
		double winH = rc.bottom;
		double capW = ArtCamGetWidth();
		double capH = ArtCamGetHeight();

		if( (winW * capH) > (winH * capW) ){
			winW = winH * capW / capH;
			rc.right = LONG(winW);
		}
		else if( (winW * capH) < (winH * capW) ){
			winH = winW * capH / capW;
			rc.bottom = LONG(winH);
		}

		pChild->SetWindowPos(&CWnd::wndTop, 0, 0, rc.right, rc.bottom, SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW);
	}

	if(1 == m_PreviewMode || 3 == m_PreviewMode || 4 == m_PreviewMode){
		ChangeScrollbar();
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	
//

void CSample_MFCView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO sc;
	GetScrollInfo(SB_HORZ, &sc);

	switch(nSBCode){
	case SB_LEFT:			SetScrollPos(SB_HORZ, 0);									break;
	case SB_ENDSCROLL:																	break;
	case SB_LINELEFT:		SetScrollPos(SB_HORZ, GetScrollPos(SB_HORZ) - sc.nPage/4);	break;
	case SB_LINERIGHT:		SetScrollPos(SB_HORZ, GetScrollPos(SB_HORZ) + sc.nPage/4);	break;
	case SB_PAGELEFT:		SetScrollPos(SB_HORZ, GetScrollPos(SB_HORZ) - sc.nPage);	break;
	case SB_PAGERIGHT:		SetScrollPos(SB_HORZ, GetScrollPos(SB_HORZ) + sc.nPage);	break;
	case SB_RIGHT:			SetScrollPos(SB_HORZ, GetScrollLimit(SB_HORZ));				break;
	case SB_THUMBPOSITION:	nPos &= 0x0000FFFF;	SetScrollPos(SB_HORZ, nPos);			break;
	case SB_THUMBTRACK:		nPos &= 0x0000FFFF;	SetScrollPos(SB_HORZ, nPos);			break;
	}

	DrawImage(NULL);

	CView::OnHScroll(nSBCode, nPos, pScrollBar);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	
//

void CSample_MFCView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO sc;
	GetScrollInfo(SB_VERT, &sc);

	switch(nSBCode){
	case SB_LEFT:			SetScrollPos(SB_VERT, 0);									break;
	case SB_ENDSCROLL:																	break;
	case SB_LINELEFT:		SetScrollPos(SB_VERT, GetScrollPos(SB_VERT) - sc.nPage/4);	break;
	case SB_LINERIGHT:		SetScrollPos(SB_VERT, GetScrollPos(SB_VERT) + sc.nPage/4);	break;
	case SB_PAGELEFT:		SetScrollPos(SB_VERT, GetScrollPos(SB_VERT) - sc.nPage);	break;
	case SB_PAGERIGHT:		SetScrollPos(SB_VERT, GetScrollPos(SB_VERT) + sc.nPage);	break;
	case SB_RIGHT:			SetScrollPos(SB_VERT, GetScrollLimit(SB_VERT));				break;
	case SB_THUMBPOSITION:	nPos &= 0x0000FFFF;	SetScrollPos(SB_VERT, nPos);			break;
	case SB_THUMBTRACK:		nPos &= 0x0000FFFF;	SetScrollPos(SB_VERT, nPos);			break;
	}

	DrawImage(NULL);

	CView::OnVScroll(nSBCode, nPos, pScrollBar);
}

//////////////////////////////////////////////////////////////////////////////////////////////
//
//	
//

void CSample_MFCView::OnMouseMove(UINT nFlags, CPoint point)
{
	CString strx, stry;
	strx.Format("%d", point.x + GetScrollPos(SB_HORZ));
	stry.Format("%d", point.y + GetScrollPos(SB_VERT));

	static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_X, strx);
	static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_Y, stry);

	CView::OnMouseMove(nFlags, point);
}



